/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Free under LGPL
*/
#include <sys/stat.h>
#include "normal.h"
#include "stdfun.h"
#include "dirloop.h"
#include "dirext.h"
#include "fspio.h"
#include "conspace.h"
#include "infor.h"
#include "fcu.h"
#include "rebuild.h"

static BOOL fit_msg;

static int NumbsCmprs(fsp_dir *dir,BYTE *readUnit)
{
 BYTE *writeUnit;
 int numb, j, i, n, clen, num_block, baseFCULen;
 MAU *mau;
 BOOL zero, len;
 fsp_lib *lib=dir->lib;
 if(lib->whichFCT){
	n=1;	num_block=SYS_ID_BLOCK;
	zero=True;	clen=FCU_NumPos+sizeof(DAU);
	}
 else {
	n=dir->DAUC,	num_block=dir->Num_FCUs_Block,
	zero=isZero(dir->Format),	clen=dir->Num_FCU_Len;
	}
 mau=(MAU *)malloc(sizeof(MAU)*n);
 baseFCULen=zero? FCU_NumPos : FCU_NumPos+sizeof(int);
 for(i=0; i<num_block; i++, readUnit+=clen){
	if(zero)numb=dir->NumbForZero++;
	if(*readUnit==1 ){
		if(!zero)numb=*(int *)(readUnit+FCU_NumPos);
		readFCU(dir,readUnit,mau,n);
		writeUnit=seekFCU(dst_dir,numb,NULL, lib->whichFCT ? (NUMB_WRITE|NUMB_SYS_ID) : NUMB_WRITE );	// must set FCU_dyw, so call it 
		if(fit_msg){
			int t;
			for(t=0; t<n; t++)if(mau[t].buf && mau[t].alen-mau[t].len>160&&mau[t].len*10/mau[t].alen<7)mau[t].alen=mau[t].len;
		}
		memcpy(writeUnit,readUnit, baseFCULen);

//		writeFCU(dst_dir,writeUnit, mau, n, 0);
//		free(writeUnit);
		addFCT(dst_dir,writeUnit);
		for(j=0; j<n; j++){
			writeDAU(dst_dir, writeUnit, mau+j, j);
			if(mau[j].len>0)len=True;
			}
		if(len)writeFCU(dst_dir, writeUnit, 0);
		free(writeUnit);

		freeMAU(mau, n);
	}
//  because don't break copys, so ignore err 
 }
 free(mau);
 return 1;
}

static int ReFixLen(int cnt,int use)
{
if(use<30){
	if(cnt<use)cnt=use;
	}
else if(use>30&&use<80)cnt=use/2;
          else if(use>80&&cnt<32)cnt=32;
return cnt;
}

void getPdPara(fsp_dir *dir, un_Int *lst)
{
   *lst=dir->Format;
   lst[1]=fit_msg? ReFixLen(dir->Num_FCUs_Block,dir->selfnumbs) : dir->Num_FCUs_Block;
   lst[2]=fit_msg? ReFixLen(dir->Dir_FCUs_Block,dir->selfdirs) : dir->Dir_FCUs_Block;
   lst[3]=dir->DAUC;
   lst[4]=dir->mode;
}

inline int DirsCmprs(fsp_dir *pcdir,fsp_dir *dir)
{
un_Int lst[pd_param_cnt];
char *dirnam;
pd_close(dst_dir, 0);
dirnam=pdPathNam(dir,NULL,0);
getPdPara(dir,lst);
dst_dir=pd_creat((fsp_dir *)LibCmpr,dirnam,lst);
free(dirnam);
return 1;
}

char *fixpath(const char *pthnam, const char *tmp)
{
int nnam=0, dirlen, i;
char *fcreat, *ptr;
ptr=strrchr(pthnam,'/');
dirlen=ptr ? ptr-pthnam+1 : strlen(pthnam);
fcreat=(char *)malloc(dirlen+96);
for(i=0; i<dirlen; i++)fcreat[i]=pthnam[i];
do
	(void)sprintf(fcreat+dirlen, "%d%s", ++nnam, tmp);
while(access(fcreat, F_OK)==0);
return fcreat;
}

static const char compfile[]="rebuild.fsp";
fsp_lib *fspRebuild(fsp_lib *send,const char *filenam, int msg)
{/* if cmpr send, then return send, else return NULL */
  int rt;
  un_Int lst[pd_param_cnt+1];
  dskadr_t diradr;
  fsp_dir *dir1;
  char *ptr;
  const char *ftmp, *lnktmp;
  struct stat sst, cmpst;
  if(filenam){
	send=fspUse(filenam, (OpenSpace)(CompactMsg|FspError|ScriptError|FastBuf), -2);
	if(send==NULL)return NULL;
	}
  lnktmp=realpath(send->fname, NULL);
  ftmp=fixpath(lnktmp, compfile);
  fit_msg=msg&OptiFit;

  getPdPara((fsp_dir *)send,lst);
  lst[pd_param_cnt]=send->zcachsiz;
  LibCmpr=fspCreat(ftmp, lst, True);
  if(LibCmpr==NULL){
	if(filenam)fspClose(send,NULL);
	_err_: PrnTxt(0, 31, ftmp); fspHB(idxdscpt,1);
	send=NULL;
	goto _ex_;
	}
  fstat(send->fpt->_fileno, &sst);	fstat(LibCmpr->fpt->_fileno, &cmpst);
  if(cmpst.st_uid!=0 && cmpst.st_uid!=sst.st_uid){
	idxdscpt=NoFileRight_30;
	goto _err_;
	}
  if(msg&ShowTips){
	msgShow( filenam? send->fname : SPC );
	msgShow("  rebuild ...");
	}
  dst_dir=(fsp_dir *)LibCmpr;
  send->whichFCT=True;
  BrowNumbs((fsp_dir *)send, NumbsCmprs); // sys_id, content above 2 line
  rt=DirFullBrow((fsp_dir *)send,7,NumbsCmprs,DirsCmprs);
  pd_close(dst_dir, 0);
// puts("close");
  ptr=pdPathNam(send->CurDir,NULL,0);
  dir1=DirOpen((fsp_dir *)LibCmpr,ptr);
  free(ptr);
  diradr=dir1->own_adr;
  LibCmpr->DefaultDir=diradr;
  fspClose(LibCmpr,NULL);
  LibCmpr=NULL;/* this is flags, must clear it */
  if(rt){
	int i=send->openIdx;
//	fspDestroy(send, extDest);
	if(filenam)send->DefaultDir=isRoot(send->CurDir) ? 0 : send->CurDir->own_adr;
	fspClose(send,NULL);
	remove(lnktmp);
	rename(ftmp, lnktmp);
	if(cmpst.st_uid!=sst.st_uid)
		chown(lnktmp, sst.st_uid, sst.st_gid);
	if(cmpst.st_mode!=sst.st_mode)
		chmod(lnktmp,sst.st_mode);
	if(filenam==NULL){
		send=fspOpen(lnktmp, DectName);
		workspace[i]=send;
		send->openIdx=i;
		send->DefaultDir=diradr;
		send->fname=lnktmp;
		setCurPd(send);
		goto _jmp_;
	}
  }
_ex_:  free((void *)lnktmp);
_jmp_:  if(ftmp!=compfile)free((void *)ftmp);
  return 	filenam ? NULL:send;
}

