/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Free under LGPL
*/

#include "normal.h"
#include "fspdir.h"
#include "fspio.h"
#include "rebuild.h"
#include "conspace.h"
#include "stdfun.h"
#include "infor.h"
#include "dlist.h"
#include "script.h"
#include "shellcom.h"

const char curSpace[]="Create workspace : %d", RLS[]=".rls",
	*pExeNam[4]={".dpp", ExtFSP, RLS, NULL };

extern char *OutBuf;

void (*extDest)();

int runinginfo;

fsp_lib *workspace[SPACELIMIT];

void setCurPd(fsp_lib *lib)
{
   if(lib->DefaultDir>40){
	lib->CurDir=pdRead(lib,pdAlloc(),NULL,lib->DefaultDir);/* default dir */
	if(pGetPdExt)pGetPdExt(lib->CurDir);
   }
}

BOOL putFspAs(fsp_lib *lib, int i)
{
if(i<-1)return False;
if(i==-1)for(i=0; i<SPACELIMIT&&workspace[i];i++);
else if(workspace[i]){
	fspHB(55, 1);
	return False;
	}

if(i<SPACELIMIT){
  workspace[i]=lib;
  lib->openIdx=i;
  return True;
  }
else DefaultManu(46);
return False;
}

char *sysIdRead(fsp_lib *lib, int numb)
{
MAU send;
num_read((fsp_dir *)lib, numb, &send, 1, NUMB_SYS_ID|FREE_READ);
return send.buf;
}

#define IsAbsPath(fnam)	( *fnam=='\\' || *fnam=='/')

fsp_lib *fspUse(const char *fnam, OpenSpace msg, int n)
{
  fsp_lib *lib=fspOpen(fnam, msg);
  if(idxdscpt>0x7ffd){
      if( msg & OpenAlway )lib->openMode=OpenAlway;
      if(n>-2&&putFspAs(lib, n)==False){ fspClose(lib,NULL); return NULL; }
      if(msg&HasFullPath)lib->fname=fnam;
      else {
	const char *fn=lib->fname;
	if( ! IsAbsPath(fn) ){
	  lib->fname=fullname(fn);/* curprgnam perhan is filename */
	  free((void *)fn);
	}
       }
      if(msg&OpenLastDir)setCurPd(lib);
      if((msg&FspError)&&idxdscpt<0x7ffd)reportBug();
      if(msg&RScript){/* read script */
	char *pt=sysIdRead(lib,SCRIPT_ID);
	if(pt){
		msgShow(pt);
		free(pt);
		}
	}
      return lib;
    }
  else if(msg&CompactMsg){
	char *pt=NULL;
	int nmb=idxdscpt;
	if(nmb==1){
	   fsp_dir *dir=pd_open((fsp_dir *)*workspace, "Compact", DIR_READ);
	   if(dir){
		MAU mau[2];
		int i=0;
		while((num_read(dir, i, mau, 2, FREE_READ))!=NULL){
			pt=memstr((const char *)fspCtrl, prognamLen, mau[0].buf, mau[0].len,1|2);
			if(pt)msgShow(mau[1].buf);
			freeMAU(mau,2);
			if(pt)break;
			i++;
		}
		pd_close(dir, 0);
	   }
	   free(lib);
	}
	if(pt==NULL){
	   if((msg&ScriptError)==0)fspHB(nmb,True);
	   else idxdscpt=nmb; /* reset old-value, NumbScan change idxdscpt, for script */
	   }
	}
return NULL;
}

int indexUsedLib(const char *fnam, const char *inpPath)
{
int i;
char *ptr=IsExec(fnam, pExeNam, inpPath);
if(ptr){
  char *pth;
  pth=fullname(ptr);  free(ptr);
  for(i=0; i<SPACELIMIT && (workspace[i]==NULL ||strcmp(pth,workspace[i]->fname)); i++);
  free(pth);
  return i<SPACELIMIT? i:-1;
}
return -1;
}

fsp_lib *fspSpace(const char *pth, OpenSpace msg, int n)
{
fsp_lib *lib1;
const char *pt=NULL;
int i=indexUsedLib(pth, NULL);
if(i<0){
  lib1=fspUse(pth, msg/* norm=1+2+4+8 */, n);
  if(lib1 && (msg&OpenAlway)==0)pt=curSpace;
}
else if(i>0){
//	msgShow("Current space"); return lib0;
	pt="\npop %d as current space";
	lib1=workspace[i];
	}
       else { // =0
	fspHB(50/* self-rtl */,True);
	return workspace[0];
	}
bakdscpt=0x7fff;
if(lib1&&(msg&FspOpenInfo)&&(diguei==0||runinginfo)){
	fspInfo(lib1->CurDir, OutBuf);
	msgShow(OutBuf);	
	pdInfo(lib1->CurDir, OutBuf);
	msgShow(OutBuf);
	}
if(pt&&n>-2){
	if(getMsg){
		lock=-1;
		if(i>0)pt++;
	}
	(void)sprintf(OutBuf, pt, lib1->openIdx);
	msgShow(OutBuf);
	lock=0;
}

return lib1;
}

fsp_lib *fspCreat(const char *fnam, const un_Int *pms, BOOL fastbuf)
{
FILE *pff;
if((pff=fopen64(fnam,"wb+"))!=NULL){
    char buff[32];
    int zn=pms[pd_param_cnt]>1 ? pms[pd_param_cnt] : 2;
    fsp_lib *lib=fspAlloc(zn);
    if(fastbuf==False)setbuf(pff, NULL); /* real time protect data */
    idxdscpt=0x7fff;
    fspTime(0, lib->datebuf);
    lib->fpt=pff;
    lib->name[0]='/';
    setPdPara((fsp_dir *)lib,pms); /* mdf|=1  set in*/
    lib->parent_adr=1;
    lib->SysNum_FCUs_Block=SYS_ID_BLOCK;
    lib->CmprSiz=16; /* k */
    lib->cmprPer=30;
    memcpy(buff, FileFmt, headblockSize-2);
    buff[fmt_CtrlSize]=CTRLSIZE-1;  /* prognamLen+4 */
    buff[fmt_CtrlSize+1]=zn;
/*    lib->ver1=buff[prognamLen+1];
    lib->ver2=buff[prognamLen+2];
    lib->ver3=buff[prognamLen+3];
    lib->CtrlSiz=CTRLSIZE-1;
   lib->zcachsiz=zn
*/
    memcpy(&lib->ver1, buff+prognamLen+1, 5);
    fwrite(buff, headblockSize-1, 1, pff); /* headblockSize-1: zcachsiz will save when fspClose */
    lib->fsz=CTRLSIZE-1+headblockSize;
    lib->useSize=CTRLSIZE-1+headblockSize;
    lib->fname=fullname(fnam);
    return lib;
}
else idxdscpt=UnCreat_11;
return NULL;
}

void fspDestroy(fsp_lib *lib, void (*fun)(void *p))
{
if(lib&&(lib->openMode&OpenAlway)==0){
  workspace[lib->openIdx]=NULL;
  lib->DefaultDir=isRoot(lib->CurDir) ? 0 : lib->CurDir->own_adr;
  if(fun)fun(lib);
  fspClose(lib,fspRebuild);
  }
}

