/*
	Designed & modify by Linjianghua
	Free under LGPL
*/

#include <stdio.h>
#include "infor.h"
#include "tds.h"
#include "stdfun.h"
#include "normal.h"

#define _MSG_(n)		(I_CmdNum+n)

/*-------- Setfiledata member ---------*/
static int ErrMsg,/* have no eddect val flag */
	oDatLen, nDatLen;
/*_____________________________________ */

void FreeTD(TxtDat *conMsg, int Allclear)
{
int i;
if(conMsg->fileRec)free(conMsg->fileRec);
if(conMsg->invfile)free(conMsg->invfile);
if(conMsg->ReVar)free(conMsg->ReVar);
if(conMsg->oDat){
	free(conMsg->oDat);
	free(conMsg->oLen);
	}

if(conMsg->numBlks){
	for(i=0; i<conMsg->curNumBlk; i++)free(conMsg->numBlks[i]);
	free(conMsg->numBlks);
}

if(conMsg->memDblk){
	for(i=0;i<conMsg->useDblkCount;i++)free(conMsg->memDblk[i]);
	free(conMsg->memDblk);
}

if(Allclear)free(conMsg);
else memset(conMsg,0,sizeof(TxtDat));
}

inline void DatCtrlApp(DatCtrl *ctrl,int addcn)/* realloc oDat,nDat */
{
if(ctrl->toluse>=ctrl->tolmem){
char **dat1, **dat2;
unsigned int *len1, *len2;
ctrl->tolmem += addcn;
dat1=(char **)zalloc(ctrl->tolmem*2*sizeof(char *)+ctrl->tolmem);
dat2=dat1+ctrl->tolmem;
len1=(unsigned int *)zalloc(ctrl->tolmem*2*sizeof(unsigned int));
len2=len1+ctrl->tolmem;
if(ctrl->toluse>0){
    register int t;
    for(t=0;t<ctrl->toluse;t++){
	dat1[t]=ctrl->dat1[t];	len1[t]=ctrl->len1[t];
	dat2[t]=ctrl->dat2[t];	len2[t]=ctrl->len2[t];
	}
    free(ctrl->dat1);		free(ctrl->len1);
	}
 ctrl->dat1=dat1;	ctrl->dat2=dat2;
 ctrl->len1=len1;	ctrl->len2=len2;
 }
}

static void AddMsg(char **dat, char *add_)
{
unsigned int vln, dln;
char *vp;
vln= *dat? strlen(*dat):0;
dln=vln+strlen(add_)+8; /* in fact, alloc mem at least:len+1 every time. */
vp=(char *)malloc(dln);
if(*dat){
	scopy(vp,*dat);
//	vp[vln++]='\r';
	vp[vln]='\n';
	scopy(vp+vln+1,add_);
	free(*dat);
	}
else scopy(vp,add_);
*dat=vp;
}

inline int IsSetting(char *txt, const char *fieldnam, int *Val)
{/* [ Mode set = 1 ]   0 : normal, 1 : bin, 2 : reset */
char *pt;
int len=fmtvalue(txt, 1);
int fg=0;
if(len==0)return 1;  /* is the mode,so skip */
if( *txt!='[' || txt[len-1]!=']' )return False; /* is not mode */

/* ValSet=0; have done */
txt[len-1]=0;	txt++;
pt=strchr(txt,'=');
if(pt){
	*pt=0;	fmtvalue(txt,1);
	if(strcmp(txt,fieldnam)==0){
		fmtvalue(++pt,1);
		*Val=atoi(pt);
		fg=1;
	}
}
return fg;
}

static char **ReAppDat(char **dat,unsigned int *m,unsigned int n)
{/* *m is dat's count  */
if(*m<=n){
char **tmp;
int a, cn;
*m += 8; cn=*m;
tmp=(char **)malloc( cn * sizeof(char *) );
for(a=0; a < cn ; a++)tmp[a]=a<n? dat[a]:NULL;
if( n > 0 )free(*dat);
return tmp;
	}
else return dat;
}

inline int VerifyDat(TxtDat *conMsg,char *pt,char CH,int msg,BOOL *IsRem)/* i>=0 the dat is eddect, 0 no eddect  */
{
int i, t, set, tn=conMsg->toluse, cur=tn;
char *pi, **Org, **New;
unsigned int *olen, *nlen;
DatCtrlApp((DatCtrl *)&conMsg->toluse,32);
olen=conMsg->oLen;	nlen=conMsg->nLen;
Org=conMsg->oDat;		New=conMsg->nDat;

if( CH>125 )goto _skp_;
if(ignoreStr(pt,IsRem,CH)||
  IsSetting(pt,"Mode set",&conMsg->valSet))return -1;
if(pi=strchr(pt,'='))*pi++=0;

if((oDatLen=fmtvalue(pt,1))==0)return -1;
nDatLen=pi ? fmtvalue(pi,1) : 0;

if((conMsg->valSet&2) && pi ){	Org[tn]=pi;	New[tn]=pt;
	olen[tn]=nDatLen;	nlen[tn]=oDatLen;
	}
else { Org[tn]=pt;	New[tn]=pi;
	olen[tn]=oDatLen;	nlen[tn]=nDatLen;
	}

if((set=conMsg->valSet&1)){
	int type, L;
	const char *tmp=getints(Org[tn], &type);
	if(tmp){
		while(*tmp==32||*tmp==9)tmp++;
		Org[tn]=(char *)atoi_lst(tmp, &L, type);
		olen[tn]=L*intType[type];
		}
	if(New[tn]){
		if( (tmp=getints(New[tn], &type)) ){
			while(*tmp==32||*tmp==9)tmp++;
			New[tn]=(char *)atoi_lst(tmp, &L, type);
			nlen[tn]=L*intType[type];
		}
	}
}
else if((set&1)==0)
 _skp_:for(t=0;t<tn;t++){
 if(memstr(Org[cur], olen[cur], Org[t], olen[t], 1|(msg&MemStrCase))){
   if(msg_memstr){
	if(New[t]&&New[cur]&&stricmp(New[t],New[cur])==0)return -1; /*  2 both equ */
	if((msg&CanSameVar)==0){ /* can't set mult-val */
		AddMsg(&conMsg->ReVar,Org[cur]);
		conMsg->cnReV++;	ErrMsg=True;
		return -1;
			}
	else break;
	  }
  else {
	int oL=olen[cur], nL=nlen[cur];
	pi=Org[cur];	pt=New[cur];
	for(i=tn;i>t;i--){ Org[i]=Org[i-1];	olen[i]=olen[i-1];
	  New[i]=New[i-1];	nlen[i]=nlen[i-1];
	}
	Org[t]=pi;		New[t]=pt;
	olen[t]=oL;		nlen[t]=nL;
	cur=t;/* adjust (pos) */
	break;
	 }
  }
}/* is loaded? */
conMsg->toluse++;
return cur;
}

static char **CalcFiles(TxtDat *conMsg,char *inpt, int *cn)
{/* use setagrv replace */
char *pt, **fname, *hd;
int n=10;
unsigned int fn=10, tol=0, t;
fmtinp(inpt, &n, ";,\n\r", '\n');
fname=(char **)zalloc(10*sizeof(char *));
hd=inpt;	pt=inpt;
while(*pt){
  if(*pt=='\n'||pt[1]==0&&fname[tol]!=pt){
	if(*pt=='\n')*pt=0;
	fname[tol]=hd;  hd=pt+1;
	for(t=0;t<tol;t++)if(strcmp(fname[t],fname[tol])==0)goto _skp_;
	if(conMsg->fileRec&&strstr(conMsg->fileRec,fname[tol])||
		conMsg->invfile&&strstr(conMsg->invfile,fname[tol]))goto _skp_;
	fname=ReAppDat(fname,&fn,++tol);
	}
_skp_: pt++;
}
*cn=tol;
return fname;
}

unsigned int MakeTD(TxtDat *conMsg,char *buf, int msg)/* return data's count */
{/* buf must heap,because it would be free */
unsigned int rt=0;
if(buf){
  unsigned int i, len=strlen(buf)+1, n=conMsg->toluse, datlen=0;
  char chr, *pt=buf;
  BOOL IsRem=False;
  conMsg->valSet=0;
/* above is init some members val of class */
  for (i=0; i<len; i++){
	chr = buf[i];
	if(strchr("\r\n;", chr)){
	  buf[i]=0;
	  if(VerifyDat(conMsg,pt,chr,msg,&IsRem)>-1)datlen += oDatLen+nDatLen+2;
	  if(buf[i+1]==10||buf[i+1]==13/* unix */){ pt=buf+i+2; i++; }
	  else	pt=buf+i+1;
	}
   }

  rt=conMsg->toluse-n;
  if(rt){
	conMsg->memDblk=ReAppDat(conMsg->memDblk, &conMsg->memDblkAlloc, conMsg->useDblkCount);
	if(datlen+128 < len){  //====compacted ==========
	    char **Org=conMsg->oDat, **New=conMsg->nDat;
	    pt = (char *)malloc(datlen + 4);
	    conMsg->memDblk[conMsg->useDblkCount++] = pt;
	    while(n<conMsg->toluse){
		memcpy(pt, Org[n], conMsg->oLen[n]);
		Org[n] = pt;
		pt += conMsg->oLen[n] + 1;
		if(New[n]){
			memcpy(pt, New[n], conMsg->nLen[n]);
			New[ n ] = pt;
			pt += conMsg->nLen[n] + 1;
		}
		n++;
   	    }
   	goto _skp_;
	} //====compacted ==========
	else conMsg->memDblk[conMsg->useDblkCount++] = buf;
  }
  else _skp_: free(buf);
/*ReCmpbk(rt);*/
}
return rt;
}

void TDSMsg(int id, const char *cap, void *X)
{
	char *msg=GetManu(id);
	popMsg(msg, cap, -4, X);
	free(msg);
}

/* msg bits :
0 pop msg for show no eddect loaded data.
1 CASE source
2 bit set 0, no mult-var set,
3 bit set 1, show errmsg
above is bit pos  //default is 1+0+4 
*/
int CreatTD(TxtDat *TDS,char *fnames, int msg, void *X, StrList *lst)
{
char **fn, *buf;
int j, cnOrg=0, fcount;
unsigned int len;
static const char cap[]="TDS";
if(fnames==NULL||fnames[0]==0){
	TDSMsg(_MSG_(1), cap, X);
	goto _skp_;
	}

fn=CalcFiles(TDS,fnames,&fcount);
if( (msg&TDSInfo) && fcount==0){
	free(fn); 
	TDSMsg(_MSG_(3), cap, X);
	return 1;
	}
cnOrg=TDS->cnRec;	ErrMsg=False;
/*-------------processe file----------------*/
for(j=0;j<fcount;j++)
  if((buf=ReadFile(fn[j],&len,True, X, lst))!=NULL&&buf!=fn[j]){
	if(MakeTD(TDS,buf,msg)>0){  /* return add cn */
	    AddMsg(&TDS->fileRec,fn[j]);
	    TDS->cnRec++;
	}
	else AddMsg(&TDS->invfile,fn[j]); /* set dat=0 */
  }
  else ErrMsg=True;
/* ----processe file end----------- */
free(fn);
if(TDS->cnRec==cnOrg){/* msg:some use no need this warn */
   if(msg&TDSInfo)TDSMsg(_MSG_(2), cap, X);
_skp_:   if(cnOrg==0)return 2;
}

if(ErrMsg && (msg&CanSameVar)==0 && (msg&ShowError) && TDS->ReVar)popMsg(TDS->ReVar, "Reload", -4, X);
return 0;
}
