/*
	Write & edit by Linjianghua(xempo) 2005-2006, 2014
	Free under LGPL
*/

#include "jxswitch.h"
#include "fsptime.h"
#include "calc.def"
#include "normal.h"
#include "stdfun.h"
#include "fspdir.h"
#include "divpage.h"
#include "infor.h"
#include "input.h"
#include "../numb/write.h"
#include "../objcom/comm.def"
#include "datastru.h"
#define  FieldLimit  20

char d_Type[FieldLimit];
BYTE cap_Len[FieldLimit], fd_Len[FieldLimit];

void DivExtDir(fsp_dir *dir)
{
	dir->CapLen=dir->DataType+dir->cols;
	dir->FieldLen=dir->CapLen+dir->cols;
	dir->Cap=dir->FieldLen+dir->cols;
}

void GetExtDir(fsp_dir *dir)
{
if(dir&&(dir->Format&SimpleBase)){
	fsp_lib *lib=dir->lib;
	dkread(lib,dir->own_adr+DIR_SAV_SIZ,&dir->cols,OFFLEN,1);/* must modify */
	dir->DataType=(unsigned char *)malloc(dir->StructLen);
	dkread(lib,dir->pStruct,dir->DataType,dir->StructLen,1);
	DivExtDir(dir);
}
}

char *MakeField(fsp_dir *dir,char *inpbuf,char *pts)
{
char **plst, *ptr;
int cn, col=dir->cols++;
plst=setargv(inpbuf, "\t ", &cn);
cap_Len[col]=strlen(inpbuf)+1;
d_Type[col]='c';	fd_Len[col]=8;
if(cn>1){
	  d_Type[col]=*plst[1];
	  if(cn>2)fd_Len[col]=atoi(plst[2]);
	}
dir->DataLen+=d_Type[col]!='t'? (fd_Len[col]>1? fd_Len[col]:8) : 5;
if(pts){ ptr=(char *)malloc(dir->Num_FCU_Len+cap_Len[col]+4);
	memcpy(ptr,pts,dir->Num_FCU_Len);
	scopy(ptr+dir->Num_FCU_Len,inpbuf); 
	free(pts); pts=ptr;
	}
else pts=strdup(inpbuf);
dir->Num_FCU_Len+=cap_Len[col];
dir->StructLen+=cap_Len[col]+3;
free(plst);
return pts;
}

void FixField(fsp_lib *lib,fsp_dir *dir,char *pts)
{
if(pts&&*pts){
char *ptr;
_Int len=dir->StructLen;
fsp_dir *pdir=DirOpen(dir, "..");
if(pdir){
	pdir->selfsize+=len;/* ought to direct(pos offer) write _Into file */
	pdir->mdf|=1;
	pd_close(pdir,1);
	}
dir->aBSC=4; /* change ... */
ptr=(char *)malloc(len+2);
memcpy(ptr,d_Type,dir->cols);
memcpy(ptr+dir->cols,cap_Len,dir->cols);
memcpy(ptr+dir->cols*2,fd_Len,dir->cols);
memcpy(ptr+3*dir->cols,pts,len-3*dir->cols);
dir->pStruct=lib->fsz;
dkwrite(lib,lib->fsz,ptr,len);/* field */
dir->DataType=(BYTE *)ptr;
DivExtDir(dir);
lib->useSize+=len;
lib->fsz+=len;
}
/*dir->savelen+=OFFLEN;*/
/*dkwrite(lib,dir->Own_FCU_Addr,dir,Dir_FCU_Len); write dir_stat */
/*lib->fsz+=OFFLEN;*/
dir->mdf|=1;
}

static const char divField[]="\n\r";
BOOL CreatField(fsp_lib *lib,fsp_dir *dir,char *txt)
{
if(dir&&(dir->Format&SimpleBase)){
char *buf=txt, *pts=NULL;
BOOL noUse=False;
dir->cols=0; dir->Num_FCU_Len=0;
/*=========================================*/
 while(buf&&*buf){
 if((txt=strchrs(buf,divField))!=NULL)
	while(strchr(divField,*txt))*txt++=0;
  if(ignoreStr(buf,&noUse,10)==False){
    fmtvalue(buf, 1);
    pts=MakeField(dir,buf,pts);
  }
 buf=txt;
 }
/*========================================*/
FixField(lib,dir,pts);
return True;
}
return False;
}

int MakeStruct(fsp_lib *lib,fsp_dir *dir)
{
if(dir){
int key=dir->Format;
if(key&SimpleBase){
  dir->Format=4224;/* SimpleBase|(1<<12) */
  if((key&256)==0){
  char *pts=NULL;
  dir->Num_FCU_Len=0; 
  showUsage(FSP_mkstruct);
   _loop_:  *InpBuf=0;	printf("Field: ");
    key=inCon(InpBuf, 1023);
    if( *InpBuf ){
    switch(key){
    case '#' :	if(InpBuf[1]==0)goto _out_;
	break;
    case Esc : goto _ex_;
    default : if(*InpBuf)pts=MakeField(dir,InpBuf,pts);
	}
   goto _loop_;
  }
  _out_: FixField(lib,dir,pts);
  _ex_: if(pts)free(pts);
  }
return key;
}
}
return 0;
}

const char NotSimpleBase[]="Not SimpleBase !";
void ListStru(/*fsp_lib *lib,*/fsp_dir *dir1)
{
if(dir1->Format&SimpleBase){
   int i, len=0;
   for(i=0;i<dir1->cols;i++){
	printf("%s; %c; %d\n", dir1->Cap+len,dir1->DataType[i],dir1->FieldLen[i]);
	len+=dir1->CapLen[i];
	}
}
else msgShow(NotSimpleBase);
}

int SDBCTinit(fsp_lib *lib,fsp_dir *dir,int pos)
{
SDBCT dfct;
dfct.addr=lib->fsz;
dfct.use_cnt=1;
dfct.alloc_cnt=1;
dkwrite(lib,pos, &dfct, dir->Num_FCU_Len);/* write one SDBCT's addr to stat-unit */
lib->FCU_dyw=lib->fsz;/* is NumbForZero */
char *dat=(char *)zalloc(sizeof(SDBCU)*dir->aBSC);
appFCT(dir, dat, sizeof(SDBCU)*dir->aBSC);
return dfct.addr;
}

BYTE statbuf[64];
BYTE *SDBseek(fsp_dir *dir,int No, int msg)
{
if(dir){
BYTE *dat_stru, *stat_buf, *stat_buf2,
*pStat,/* RescuMsg,*/
stru_cnt;
fsp_lib *lib=dir->lib;
int j, b0;
int /* dlen, dlen1,*/ idxStat, dfct_len, dat_len,
strulen, d, d2, dStatLen, nStatLen; /* perhan dStatLen*nStatLen>255, tcc would flow bit */
int seg, segbk=0, pos;
BOOL savestat=False;
SDBCT *dfct, *dt_cu2, *mv_dfct;
SDBCU *ds, *ds_buf, *ds_buf2;
// SDBCTlinkor *stat_ptr, *ptrStat;
BYTE *lnkor, *pLnkor;
if(lib->fpt==NULL){ idxdscpt=NoBuff_2; return NULL; }
if(dir->pStruct==0){ idxdscpt=NoStruct_8; return NULL; }
/* root can't use for #data */
lib->FCU_dyw=0; /* init every call */
idxdscpt=0x7fff; /* no-error code */

dat_stru=msg!=NUMB_WRITE? NULL:statbuf;

dStatLen=dir->Num_FCUs_Block;
stru_cnt=dir->aBSC;
nStatLen=dir->Num_FCU_Len;

if(msg!=NUMB_FCU_BLANK){ seg=dir->numb_FCT; dir->NumbForZero=0; }
else seg=dir->cur_numb_FCT;
/*  RescuMsg = dir->StatFlag; */
memset(statbuf,0,nStatLen);

strulen=sizeof(SDBCU);
dat_len=strulen*stru_cnt;
dfct_len=dStatLen*nStatLen+NCTlinkor_size();
if(seg==0){
   if(msg==NUMB_WRITE){
//	static const _Int cnt[2]={1};/* Write: must set stat-cnt is 1 no 0 */
	pos=lib->fsz;
	dir->numb_FCT=pos;
	char *dat=(char *)zalloc(dfct_len);
	dat[dfct_len-2]=1;	// dat[dfct_len-1]=0;
//	appFCT(dir,dfct_len,cnt,4);/* creat stat-blank */
	appFCT(dir, dat, dfct_len);

	SDBCTinit(lib,dir,pos);
	}
   else idxdscpt=NoNumb_4;
   return dat_stru;
  }

stat_buf=(BYTE *)malloc(dfct_len);
lnkor=(BYTE *)(stat_buf+dfct_len-NCTlinkor_size());
ds_buf=(SDBCU *)malloc(dat_len);
while( seg>0 ){
  if(dkread(lib,seg,stat_buf,dfct_len,1)<1){	/* file error */
     idxdscpt=ErrScnFile_5;  dat_stru=NULL;
     break;
	}
  if(msg==NUMB_FCU_BLANK){ dir->cur_numb_FCT=NCTlinkor_addr(lnkor); return stat_buf; }
  if(dir->NumbForZero+NCTlinkor_cnt(lnkor)<No){
	dir->NumbForZero+=NCTlinkor_cnt(lnkor);
	goto loop;
	}
/* ------- printf("--- %d ---\n",NCTlinkor_cnt(lnkor)); ---------- */
/* ======================== in one stat ============================= */
 for(idxStat=0,pos=seg,pStat=stat_buf; idxStat<dStatLen; idxStat++,pos+=nStatLen,pStat+=nStatLen){
/*---------printf("cnt:%d,%d\n",*pStat,pStat[1]);------------*/
  dfct=(SDBCT *)pStat;
  if(/* pStat->use_cnt>0 */ *pStat>0){
    if(dir->NumbForZero+dfct->use_cnt<No){
	dir->NumbForZero+=dfct->use_cnt;
	continue;
	}
    dkread(lib,dfct->addr,ds_buf,dat_len,1);
/*    printf("dfct-adr=%ld,pos=%ld\n",dfct->addr, pos); */
    for(ds=ds_buf,d=0;d<stru_cnt;d++,ds++){
     if( ds->Flags==1 ){
       if(dir->NumbForZero++==No)switch(msg){/* find it */
        case NUMB_WRITE : write_numb: 
	if(dfct->alloc_cnt<stru_cnt){
	dfct->alloc_cnt++; dfct->use_cnt++;
	SelfIns: NCTlinkor_cnt(lnkor)++; 
	if(ds->Flags){
	  memmove(ds+1,ds,(stru_cnt-d-1)*strulen);
	  memset(ds,0,strulen);/* must do */
	}
	dkwrite(lib,dfct->addr,ds_buf,dat_len);
	if(savestat==False)dkwrite(lib,pos,dfct,2);
	/* self adj addr-val */
	}
	else { /* in one stat */
	dt_cu2=dfct+1; /* (SDBCT *)(pStat+nStatLen); */
	if(idxStat+1<dStatLen&&dt_cu2->addr!=0&&dt_cu2->alloc_cnt<stru_cnt){ /* next dfct */
	   ds_buf2=(SDBCU *)malloc(dat_len);
/*-----------------puts("next it");----------------*/
	   dkread(lib,dt_cu2->addr,ds_buf2,dat_len,1);
	   memmove(ds_buf2+1,ds_buf2,(stru_cnt-1)*strulen);
	   memcpy(ds_buf2,ds_buf+stru_cnt-1,strulen);
	   dt_cu2->alloc_cnt++; dt_cu2->use_cnt++;
	   dkwrite(lib,dt_cu2->addr,ds_buf2,dat_len);
	   free(ds_buf2);
	   if(savestat==False)dkwrite(lib,pos+nStatLen,dt_cu2,nStatLen);/* save alloc_cnt, use_cnt & addr for new-dfct */
	   goto SelfIns;
	  }
	else if(idxStat>0&&dfct[-1].alloc_cnt<stru_cnt){
		_Int flg=False;
	/* ------- puts("back it"); -------- */
		ds_buf2=(SDBCU *)malloc(dat_len);	dt_cu2=dfct-1;
/*--------	printf("dfct:%ld,dt_cu2:%ld\n",dfct->addr,dt_cu2->addr);------*/
		dkread(lib,dt_cu2->addr,ds_buf2,dat_len,1);
/*		printf("dfct:%ld,dt_cu2:%ld\n",dfct->addr,dt_cu2->addr);*/
		if(d>0){
		  memcpy(ds_buf2+dt_cu2->alloc_cnt,ds_buf,strulen);
		  if(--d>0)memmove(ds_buf,ds_buf+1,d*strulen);
		  ds=ds_buf+d;	  memset(ds,0,strulen);
		}
		else flg=True;
		dkwrite(lib,dfct->addr,ds_buf,dat_len);
		dt_cu2->alloc_cnt++; dt_cu2->use_cnt++;
		dkwrite(lib,dt_cu2->addr,ds_buf2,dat_len);
		if(flg){
			free(ds_buf); ds_buf=ds_buf2;
			ds=ds_buf2+dt_cu2->alloc_cnt;
			}
		else free(ds_buf2);
		NCTlinkor_cnt(lnkor)++;
		/*if(savestat==False)*/
		dkwrite(lib,pos-nStatLen,dt_cu2,2);/* save alloc_cnt, use_cnt & addr for new-dfct */
		}
	     else {/* puts("new it"); */	savestat=True;
		dt_cu2=(SDBCT *)stat_buf;
		for(b0=idxStat+1,j=b0;j<dStatLen&&dt_cu2[j].alloc_cnt>0;j++);/* current stat */
		if(j<dStatLen){	/* ----printf("move, dfct:%d,%d\n",j,idxStat); ----*/
			dt_cu2+=b0;
			memmove(dt_cu2+1,dt_cu2,(j-b0)*nStatLen);
			dt_cu2->addr=lib->fsz;

			ds_buf2=(SDBCU *)malloc(dat_len);
			memset(ds_buf2,0,dat_len);
			d2=dStatLen-d;
			memcpy(ds_buf2,ds_buf+d,d2*strulen);
			memset(ds_buf+d,0,d2*strulen);
			dt_cu2->alloc_cnt=d2;
			dt_cu2->use_cnt=d2;
			dfct->alloc_cnt-=d2;
			dfct->use_cnt-=d2;

			dkwrite(lib,dt_cu2->addr,ds_buf2,dat_len);
			
			free(ds_buf2);
			lib->fsz+=dat_len;/* replace appFCT here */
			lib->useSize+=dat_len;
			dir->selfsize+=dat_len;
			goto write_numb;
			}
	/* ----------------- in one stat end ------------------- */
		else {
		mvstat0:stat_buf2=(BYTE *)malloc(dfct_len);
		mvstat1:j=dStatLen-1; b0=j*nStatLen;
		  if(NCTlinkor_addr(lnkor)>0){/*------ puts("Ins dep stat(exist) append");----*/
			pLnkor=(BYTE *)(stat_buf2+dfct_len-NCTlinkor_size());
			dkread(lib,NCTlinkor_addr(lnkor),stat_buf2,dfct_len,1);
			dt_cu2=(SDBCT *)(stat_buf2+b0);
			if(dt_cu2->alloc_cnt>0){ /* next stat no space */
				*(dskadr_t *)pLnkor=NCTlinkor_addr(lnkor);
				memset(stat_buf2,0,dfct_len);
				memcpy(stat_buf2+dfct_len-NCTlinkor_size(),lnkor,NCTlinkor_size());
			/* --- puts("ins stat(new)..."); --- */
				NCTlinkor_addr(lnkor)=lib->fsz;
				NCTlinkor_cnt(pLnkor)=0;
				BYTE *dat=(BYTE *)zalloc(dfct_len);
				memcpy(dat+dfct_len-NCTlinkor_size(), pLnkor, NCTlinkor_size());
				appFCT(dir, dat, dfct_len);

				}
			while(j>0&&dt_cu2[-1].alloc_cnt<1){ dt_cu2--; j--; }
			memmove(stat_buf2+nStatLen,stat_buf2,j*nStatLen);
			mv_dfct=(SDBCT *)(stat_buf+b0);
			memcpy(stat_buf2,mv_dfct,nStatLen);
			NCTlinkor_cnt(lnkor)-=mv_dfct->use_cnt;

			NCTlinkor_cnt(pLnkor)+=mv_dfct->use_cnt;
			memset(mv_dfct,0,nStatLen);
			if(idxStat<dStatLen-1)dkwrite(lib,NCTlinkor_addr(lnkor),stat_buf2,dfct_len);
			else {
				dkwrite(lib,seg,stat_buf,dfct_len);
				idxStat=0; seg=NCTlinkor_addr(lnkor); pos=seg;
				dfct=(SDBCT *)stat_buf;
				memcpy(stat_buf,stat_buf2,dfct_len);/* as ptr in stat_buf, so cpy-blk */
				}
			free(stat_buf2);
			goto write_numb;
			}
			else if(segbk>0){/* puts("bak_in_stat"); */
				stat_buf2=(BYTE *)malloc(dfct_len);
				dkread(lib,segbk,stat_buf2,dfct_len,1);
				dt_cu2=(SDBCT *)(stat_buf2+b0);
				if(dt_cu2->alloc_cnt>0)goto newstat;
				pLnkor=(BYTE *)(stat_buf2+dfct_len-NCTlinkor_size());
				while(j>0&&dt_cu2[-1].alloc_cnt<1){ dt_cu2--; j--; }
				mv_dfct=(SDBCT *)stat_buf;
				memcpy(dt_cu2,stat_buf,nStatLen);
				memmove(stat_buf,stat_buf+nStatLen,b0);
				NCTlinkor_cnt(lnkor)-=mv_dfct->use_cnt;
				NCTlinkor_cnt(pLnkor)-=mv_dfct->use_cnt;
				memset(stat_buf+b0,0,nStatLen);/* set last stat to 0 */
				if(idxStat){ dkwrite(lib,segbk,stat_buf2,dfct_len);
					dfct--; idxStat--; pos-=nStatLen;
					}
				else { dkwrite(lib,seg,stat_buf,dfct_len);
					idxStat=j; seg=segbk; pos=seg+idxStat*nStatLen;
					dfct=(SDBCT *)(stat_buf+idxStat*nStatLen);
					memcpy(stat_buf,stat_buf2,dfct_len);
					}
				free(stat_buf2);
				goto write_numb;
				}
			     else { newstat: /* puts("creat new stat"); */
				NCTlinkor_addr(lnkor)=lib->fsz;/* new stat addr */
				char *dat=(char *)zalloc(dfct_len);
				appFCT(dir,dat, dfct_len);/* dfct alloc,  lib->FCU_dyw=lib->fsz;*/
				if(segbk>0)goto mvstat1;
				else goto mvstat0;
				}
			}
		}
	}

	if(savestat)dkwrite(lib,seg,stat_buf,dfct_len);
	else dkwrite(lib,seg+dfct_len-NCTlinkor_size(),lnkor,NCTlinkor_size());

/*-----------------------------------------------------------------*/
	case NUMB_DEL : 
	case NUMB_READ : 
	   lib->FCU_dyw=dfct->addr+d*strulen;
/*	   printf("FCU_dyw=%ld,ds->addr=%ld,d=%d\n",lib->FCU_dyw,ds->addr,d);*/
	   dat_stru=statbuf;
	   memcpy(dat_stru,ds,strulen);
	   if(msg==NUMB_DEL){ dir->curFCU=stat_buf;
			dir->posFCU=seg;
			dir->cur_dcu=dfct; goto outloop1;
			}
	   goto outloop;
		}/* find it */
	}
     else if(ds->Flags==0){
	switch(msg){
	case NUMB_WRITE : if(dir->NumbForZero>=dir->selfnumbs||dir->NumbForZero==No){
/*	printf("dfct=%d,adr=%ld\n",dfct->addr,ds->addr);*/
	goto write_numb;/* _numb==No is no need */
		}
/* unuseful */}
	/* msg=0; only init */
	}
	}
    }/* pStat->use_cnt>0 */
    else if(msg==NUMB_WRITE &&dir->NumbForZero==No ){
/*	printf("dfct=%d,adr=%ld\n",dfct->addr,ds->addr);*/
		ds=ds_buf; d=0;
		dfct->addr=SDBCTinit(lib,dir,pos);
		memset(ds_buf,0,dat_len);/* perhan is lasttime data, so must ...*/
		goto write_numb;
		}
}/* for-loop */
loop: segbk=seg; seg=NCTlinkor_addr(lnkor);
}/* while-loop */
outloop:  free(stat_buf);
outloop1: free(ds_buf);
if(idxdscpt>0x7ffd){
  if(!dat_stru)FailSeekMsg(msg);
  if(msg==NUMB_WRITE&&lib->FCU_dyw==0)lib->LNKDWORD=pos;/* must creat sdbcu */
}
return dat_stru;
}
idxdscpt=PthInv_7;
return NULL;
}

BYTE *GetNo(fsp_lib *lib,fsp_dir *dir,SDBCU *ds)
{/* return org-data of disk */
unsigned char *buf=(unsigned char *)malloc(dir->DataLen+2);
dkread(lib,ds->addr/* lib->FCU_dyw */,buf,dir->DataLen,1);
return buf;
}

void CvtToType(fsp_dir *dir,char *orgtxt,_Int fd_idx,void *pbuf)
{
_Int i;
int l;
struct tm dt;
float f;
double d;
switch(dir->DataType[fd_idx]){
case 'm' : /* pbuf=MemoChs; */ break;
case 't' :  smtime(orgtxt,&dt);
	    fspTime(mktime(&dt), (BYTE *)pbuf); break;
case 'i' : i=(_Int)calc(orgtxt); memcpy(pbuf,&i,2);	break;
case 'l' : l=(int)calc(orgtxt); memcpy(pbuf,&l,4);	break;
case 'f' : f=calc(orgtxt); memcpy(pbuf,&f,4);	break;
case 'w' : d=calc(orgtxt); memcpy(pbuf,&d,8);	break;
default :   i=dir->FieldLen[fd_idx];
	memcpy(pbuf,orgtxt,i);
	/**( (char *)pbuf+i )=0;*/
	}
}

void PutNo(fsp_lib *lib,fsp_dir *dir,SDBCU *du, char *buf0)
{
int j, len=0;
char *buff=(char *)zalloc(dir->DataLen+2),
**pms=setargv(buf0, "\t ", &j);
//memset(buff,0,dir->DataLen+2);
for(j=0;*pms&&j<dir->cols;j++){
/*memcpy(buff+len,*pms++,dir->FieldLen[j]);*/
  CvtToType(dir,*pms++,j,buff+len);
  len+=dir->FieldLen[j];
}

if(lib->FCU_dyw==0){
	creatFCT(dir,dir->Num_FCU_Len*dir->Num_FCUs_Block+NCTlinkor_size(),1);
	SDBCTinit(lib,dir,lib->FCU_dyw);
	}

// if(du->addr==0){/* this not need, ... */
	du->addr=lib->fsz; 
	lib->fsz+=dir->DataLen; 
/*}
else puts("SDBCT errer !");*/
dkwrite(lib,du->addr,buff,dir->DataLen);
free(buff);
du->Flags=1;
dkwrite(lib,lib->FCU_dyw,du,sizeof(SDBCU)); // lib->FCU_dyw is dy, for every pos to writedisk
lib->useSize+=dir->DataLen;
dir->selfsize+=dir->DataLen;
setFCU(dir,1);
}
