/*
	Write by xempo 2013
	Free under LGPL
*/

#include "highlight.h"
#include "editor.h"
#include "txtstyle.cpp"

// Version 0.8 |  05-29 2015

HighLighter :: HighLighter( Editor *ed, const StyleVal *color, const unsigned int *line_style) :
		QSyntaxHighlighter(ed),
		orgColor(ed->color().rgb()), edt(ed),
		c_style(freeStyles), colors(color), styleCount(__params[54] ? StyleCount : StyleCount-3),
		YHcolor(line_style[0]), BZcolor(line_style[1]), cppBZcolor(line_style[2])
{
edt->setHL(this);
}

void HighLighter::_init()
{
	inputLine=CS_Init;
	paraBack=-1;
	fnt.setBold(false);
	fnt.setItalic(false);
	fnt.setUnderline(false);
	edt->setFont(fnt);
}

// HighLighter :: ~HighLighter(){}

inline bool HighLighter::MemChr(const char *src, const char chr, const int len)
{
register int t;
for( t=0; t<len&&src[t]!=chr; t++);
return (t<len);
}

enum endStateOfLastPara {
GoOn=15,
PasteSelect=14,
EndCommitFinish=13,
FirstYH=12,
EndCommit=11, //  =>  */ ....
FirstCommit=10 // => /* ....
}; 

int HighLighter::feelFormat(const char *pt, int p)
{
  if(pt==NULL)return 0;
  register int t=-1;
  int R=-2, row=0, sc=0; // 0 norm; 1 cppBZ ; 2 cBZ;  3 YH(" ");
  while( row!=p )
    switch( pt[++t] ){
    case 0 : goto _ex_; //return sc;
    case '\n' :
_jmp_:	row++;
	break;
    case '\"' :
	if( t<1||pt[t-1]!='\\'|| t>1&&pt[t-2]=='\\' )
	switch(sc){
	case SC_Norm : sc=SC_YH; // 3
		break;
	case SC_YH /* 3 */ : sc=SC_Norm;
	}
	break;
     case '/' : 
	if(sc!=SC_YH){
	    if( t>0&&pt[t-1]=='*' )sc=SC_Norm;
	    else  switch(pt[t+1]){
		case '*'  :  sc=SC_BZ_c;
			R=row;
			break;
		case '/' : 	if(sc!=SC_BZ_c){
			  while(pt[++t]!='\n'&&pt[t]);
			  if(pt[t])goto _jmp_;
			  else return sc;
			}
		}
     	}
    }
_ex_: if(R+1>=row&&sc==SC_BZ_c&&edt->cs_feel()==true&&
	pt[t+1]!='\n'/* not emtpy line */)sc=SC_Norm;
return sc;
}


#define recoverOrg() if(inputLine!=CS_Init&&org<Idx)setStyle(org, Idx-org, orgColor, false, false, false)

void HighLighter::setStyle(int s, int len, unsigned int c, bool bold, bool italic, bool underline)
{
fnt.setBold(bold);	fnt.setItalic(italic);
fnt.setUnderline(underline);
setFormat(s, len,  fnt, c);
}

int HighLighter :: highlightParagraph( const QString &text, int paraState)
{
 if(edt->sel_feel())return PasteSelect; // delete selection when paste on hasSelected
 bool  Inputing, doPaste, BZ_SC_b=false, a_BZ_SC;
 int  S, i, cnt, P, I,
	Idx=0, org=0,
	YHstat=0, YHpos=0,
	BZposb=0; // , aBZpos=0;
 register const char *pt=(const char *)text;
 edt->getCursorPosition(&P, &I);
 switch(edt->paste_feel()){
 case 1 : edt->setPasteFeel(2);
	Inputing=true; doPaste=true;
	break;
 case 2 : Inputing=false; doPaste=true;
	break;
 default : Inputing=(inputLine==CS_Modifying);
	doPaste=false;
 }
 a_BZ_SC=doPaste;
 if( Inputing ){   // >0特殊，-9 常态iinput(modifying)
	paraState=0;	paraBack=-1;
	switch(feelFormat(edt->text(), P)){
	case SC_BZ_c /* 2 */ : BZ_SC_b=true;
			break;
	case SC_YH /* 3 */ : YHstat=1;
			break;
	case SC_Norm/* 0 */ :
			if(edt->cs_feel() )a_BZ_SC=true;  //  delete     /* ...
			else if( edt->yh_feel() )inputLine=2;
		}
	if(edt->todoMsg && (BZ_SC_b||a_BZ_SC) )edt->update=true;
   }
  else if(doPaste){
	switch(paraState){
	case EndCommitFinish :
		return EndCommitFinish; // fast
		// return 0; lower
	case FirstYH : YHstat=1;
		break;
	case EndCommit :  a_BZ_SC=true;
		break;
	case FirstCommit : BZ_SC_b=true;
	}
	paraState=0;
	}
          else {
	if(inputLine>0){
	   if(paraState==FirstYH){
		YHstat=1;
		paraState=0;
		}
	}
	else switch(paraState){
	        case EndCommitFinish :
		return EndCommitFinish; // fast
		// return 0; lower
	        case FirstYH : YHstat=1;
		break;
	        case EndCommit :  a_BZ_SC=true;
		break;
	        case FirstCommit : BZ_SC_b=true;
		break;
	        default :  /* LinesChange : */
		if(paraBack==P) // Key_Return or Key_delete(lineEnd) or backspace(lineHead)
			return FirstCommit;
//		if(inputLine!=CS_Init)return 0; // delete a line, next send paraState==0 whether return any value
	}
        }
   const  TxtStyle *txtstyle;
   const char *spt, *style, *bflm, *aflm, **ctype;
   int bf, af, SN;
   while( pt[Idx] ){
	spt=pt+Idx;
	if(YHstat%2){
		if(isYH(pt,Idx))goto _jmp_YH_;
		else goto _skip2_;
	}
	if(*spt=='/'){
		if( BZ_SC_b==false &&spt[1]=='/'){
		    for(i=2; spt[i]; i++);
		    setStyle(Idx,i,cppBZcolor, false, true, false);
		    goto _out_;
		}
		if( spt[1]=='*'){
			recoverOrg();
			switch(paraState){
			case FirstCommit :  if(inputLine==CS_Init)goto _skip2_; // 2 condition
				setStyle(0,Idx+2,BZcolor, false, true, false);
				break;
			case EndCommit :
				return inputLine!=CS_Init ? EndCommitFinish : 0;
			}
			if(BZ_SC_b==false){
				BZ_SC_b=true; BZposb=Idx++;
			}
		}
	}
	else if(*spt=='*' && spt[1]=='/' ){
		if(inputLine!=CS_Init)
			switch(paraState){
			case FirstCommit : 
				setStyle(0, (++Idx+1), BZcolor, false, true, false);
				if(edt->undo_feel()||doPaste)goto _BZ_;
				return EndCommitFinish;
			case EndCommit :
				setStyle(0, (++Idx+1), orgColor, false, false, false);
				if(edt->undo_feel())goto _BZ_;
				return EndCommitFinish;			
			}
		if(BZ_SC_b){
		    recoverOrg();
		    setStyle(BZposb, (++Idx+1)-BZposb, BZcolor, false, true, false);
		    if(Inputing)_BZ_ : a_BZ_SC=true;
		    org=Idx+1;		BZ_SC_b=false;
		    paraState=0;
		    goto _skip2_;
		}
	}

	if(BZ_SC_b==false&&isYH(pt, Idx)){
_jmp_YH_:	if((++YHstat)%2==0){
		    if(BZ_SC_b==false){
			recoverOrg();
			setStyle(YHpos, Idx-YHpos+1, YHcolor, false, false, false);
			org=Idx+1;
			}
		}
		else  YHpos=Idx;
	}
	if(BZ_SC_b||paraState==FirstCommit)goto _skip2_;

	SN=0;
_C_S_:	  txtstyle=c_style+SN;
	  ctype=CType[SN];
	  if(MemChr(txtstyle->fast, *spt, txtstyle->fastlen)){
	    bflm=txtstyle->bflm;	aflm=txtstyle->aflm;
	    bf=txtstyle->bflen;	af=txtstyle->aflen;
	    for(S=0; S<txtstyle->cnt; S++){
		style=ctype[S]; //txtstyle->StyleTxt[S];
		for(cnt=0; style[cnt]&&spt[cnt]==style[cnt]; cnt++) ;
		if(style[cnt]==0 && (Idx==0||MemChr(bflm,spt[-1], bf)) && MemChr(aflm, spt[cnt], af) ){
			if(SN<2){	i=Idx-1;
				for(cnt++; i>-1&&(pt[i]==' ' ||pt[i]=='\t');  cnt++, i--) ;
				if(pt[i]!='#' ) goto _skip1_;
				Idx=i;
				if(SN==0){  // i=Idx;
				    while(--i>-1&&pt[i]==' ' || pt[i]=='\t');
				    if(i>-1)goto _skp_;
				}
			}
			recoverOrg();
			setStyle(Idx, cnt, colors[SN].color, colors[SN].bold, colors[SN].italic, colors[SN].underline);
			_skp_: Idx+=cnt-1; org=Idx+1;
			goto _skip2_;
		}
	    }
	  }
	_skip1_: if(++SN<styleCount)goto _C_S_;
  _skip2_: Idx++;
  }
_out_: if(inputLine==CS_Modifying)inputLine=0;
else if(inputLine>0)inputLine--;

if( YHstat%2 ){
	i=Idx-1;
	while(i>YHpos &&(pt[i]==32 || pt[i]=='\t'))i--;
	if(pt[i]=='\\'){
		setStyle(YHpos, Idx-1-YHpos, YHcolor, false, false, false);
		return FirstYH;
	}
	if(org<=YHpos){
		setStyle(org, Idx-1-org, orgColor, false, false, false); //单边引号
		return 0; // ??   15-3-26
	}
}
if(BZ_SC_b){
	i=Idx-1-BZposb;
	setStyle(BZposb, i<BZposb ? BZposb : i,  BZcolor, false, true, false);
	if(inputLine!=CS_Init)
		paraBack=P; // because : delete a line, and connect as /*
	return FirstCommit;
}

recoverOrg();
return ( a_BZ_SC ||paraState==EndCommit) ? EndCommit : (inputLine>0 ? GoOn : 0 );
}
