/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Free under LGPL
*/

#include "fspdir.h"
#include "dirloop.h"
#include "infor.h"
#include "fsptime.h"
#include "stdfun.h"
#include "options.h"

static int ch_mode;
static BYTE DataBuf[FspTmLen];

void (*pChMT)(fsp_dir *dir, int msg);

#define	FspModeLen		1

int nChMT(fsp_dir *dir,BYTE *xstats)
{
if((dir->mode&FSP_OEM)==0){
  int i, chmsg=0, Num_FCUs_Block=dir->Num_FCUs_Block,
	unitlen=dir->Num_FCU_Len;/* protect bit flow */
  BYTE *unit=xstats;
  for(i=0;i<Num_FCUs_Block;i++,unit+=unitlen)
   if(*unit==1 && (unit[1]&FSP_OEM)==0 ){
	if(ch_mode!=FspTmLen)memcpy(unit+1, DataBuf, FspModeLen);
	else if(unit[1]&FSP_MW)memcpy(unit+FCU_TimePos, DataBuf, FspTmLen);
	chmsg=1;
	}
  if(chmsg)dkwrite(dir->lib,dir->pos_numb_FCT,xstats,Num_FCUs_Block*unitlen);
}
return 1;
}

int dChMT(fsp_dir *pcdir,fsp_dir *dir)
{
 if((dir->mode&FSP_OEM)==0){
	if(ch_mode!=FspTmLen){
		dkwrite(dir->lib,dir->Own_FCU_Addr+1,DataBuf,FspModeLen);
		dir->mode=*DataBuf;
		}
	else if(dir->mode&FSP_MW){
		dkwrite(dir->lib,dir->Own_FCU_Addr+D_DATEPOS,DataBuf,FspTmLen);
		memcpy(dir->datebuf,DataBuf, FspTmLen);
		}
	}
    return 1;
/* else return 2;  can't brow its beint */
}

void chMT(fsp_dir *dir0, int n, char **pm, int nCom)
{
#define Is_Mode() nCom!=FSP_chdate
  fsp_dir *dir;
  int i, msg;
  BOOL isNum;
  int numb;
  fsp_lib *lib=dir0->lib;
  /* -------- Get DataBuf begin (Init part)---------- */

 arglists *lst;
 int brwVal[BrowsModeCnt];

#define  mu2  1
 int rt=0;
 static const char *mu2mo="-M",*_mu2mo="--mode",
	*mu2ti="-T",*_mu2ti="--time";
 memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
// memset(mu2val, 0, sizeof(int)*mu2);
 ProcOpt optBrows={
	BrowsModeCnt,
	browsMode, _browsMode,
	brwVal,
	0,
	NULL
	},
  opt2={
	mu2,
	nCom==FSP_chmode ? &mu2mo : &mu2ti,
	nCom==FSP_chmode ? &_mu2mo : &_mu2ti,
	&rt,
	0,
	NULL
	};
  if( !(lst=procParas(n, pm, &optBrows, &opt2)) )return;
  if(lst->argc==0){
	fspHB(60, True);
	goto _usage_;
	}
  rt&=0x7fff;
  switch(nCom){
  case FSP_chmode : 
	if( rt ){
	      msg=cvtPara(lst->subarg->argv[0],"rwho-");
	      if(msg<0){
		fspHB(44,True);
_usage_:	showUsage(nCom);
		goto _ex_;
	      }
	      if(msg&FSP_OEM){ /* can't chmode it to OEM, only creat ... */
		fspHB(42,True); goto _ex_;
		}
	      *DataBuf=msg;
    	}
	break;
  case FSP_chdate :
	if(rt==0){
		fspHB(59, True);
		showUsage(nCom);
		goto _ex_;
	}
	struct tm dt;
	smtime(lst->subarg->argv[0], &dt);
	fspTime(mktime(&dt),DataBuf);
  }
/*------ get DataBuf end --------*/
msg=getBM(brwVal);
for(i=0; i<lst->argc; i++){
  isNum=adjNumb(lst->argv[i]);
  dir=pd_open(dir0, isNum ? divPath(lst->argv[i],&numb) : lst->argv[i], DIR_BROW );
  if(idxdscpt<0x7ffd){ reportBug(); continue; }
  if(isNum){
    BYTE *stat;
    switch(nCom){
    case FSP_chmode :
	if((stat=seekFCU(dir,numb,NULL,NUMB_BROW))!=NULL){
	  if(rt==0)showFCU(dir, stat, True);
	  else {
		if((dir->mode&FSP_OEM)==0||(stat[1]&FSP_OEM)==0)dkwrite(lib,lib->FCU_dyw+1,DataBuf,1);
		else fspHB(45,True);
	  }
	  free(stat);
	}
	else reportBug();
	break;
    case FSP_chdate :
	if((stat=seekFCU(dir,numb,NULL,NUMB_REN/* togg mode-member */))!=NULL){
	   dkwrite(lib,lib->FCU_dyw+D_DATEPOS, DataBuf, FspTmLen);
	   free(stat);
	}
	else reportBug();
//	break;
    }/* sw */
//	goto _releaseDir_;
  }
  else {
      if(rt==0)showPd(dir, dir->name);
      else switch(nCom){
	case FSP_chdate : 
		if(dir->mode&FSP_MW){
			ch_mode=FspTmLen; /* len, dkwrite(...) */
			goto _skp1_;
			}
		else fspHB(15, True);
		break;
	case FSP_chmode : ch_mode=FspModeLen; /* data len */
	_skp1_:	if((msg&LoopDirSub))msg|=LoopNum;
	     DirFullBrow(dir,msg,nChMT,dChMT);
	     if((dir->mode&FSP_OEM)==0){/* chself */
		    dkwrite(lib,dir->Own_FCU_Addr+(Is_Mode()? 1:2),DataBuf,ch_mode);
		    if(Is_Mode())dir->mode=*DataBuf;
		    else memcpy(dir->datebuf,DataBuf, FspTmLen);
	     }
	     else fspHB(45,True);
//		break;
	}/* sw */
  }
//_releaseDir_:
 if(pChMT)pChMT(dir, msg);
 pd_close(dir,1);
}
_ex_ : argsFree(lst);
}

