/*
  Designed by Linjianghua(Xempo) 2004-2006, 2010,2012
  Free under LGPL
*/

#include "input.h"
#include "infor.h"
#include "jxswitch.h"
#include "fsptime.c"

const char *modeToStr(int mode)
{
static const char RWScpt[4][6]={"Read","Write", "Hide","OEM"};
static char modestr[28];
int i;
*modestr=0;
for(i=0;i<4;i++)
  if(mode&(1<<i))strcat(modestr,RWScpt[i]);
return *modestr? modestr: "----";
}

int isNumb(const char *pt)
{
  char ch;
  while(*pt==9||*pt==32)pt++;
  while((ch=*pt)=='-'||ch=='+'|| (ch>('0'-1)&&ch<('9'+1)) )pt++;
  return(ch==9||(ch|32)==32);
}

BOOL adjNumb(char *pth)
{
if(pth){
  char  *pt;
  for(pt=pth;*pt;pt++)
	if(*pt=='\\')*pt='/';
  pt=rstrrchr(pth,'/','/');
  if(*pt==0)return False; /* is "\\" */
  return isNumb(pt);
}
else return False;
}

BOOL numNone;
char *divPath(char *pth,int *nmb)
{/* main get nmb value */
if(pth){
  char *pnmb;
  for(pnmb=pth;*pnmb;pnmb++)
	if(*pnmb=='\\')*pnmb='/';
  pnmb=strrchr(pth,'/');
  numNone=False;
  if(pnmb){
    if(isNumb(pnmb+1)){
	*nmb=atol(pnmb+1);
	if(pnmb==pth)pnmb++;
	*pnmb=0;
	}
    else numNone=True;
    return pth;
  }
  else {
    if(isNumb(pth))*nmb=atol(pth);
    else { numNone=True; return pth; }
  }
}
else numNone=True;
return NULL;
}

int paraExpre(unsigned int val, char *buf, const char *fmt)
{
int i, L=0;
*buf='-'; buf[1]=0;
for(i=0; fmt[i]; i++)
  if(val&(1<<i))buf[L++]=fmt[i];
if(L>0){
	buf[L]=0;
	return L;
	}
return 1; 
}

int cvtPara(const char *pm, const char *fmt)
{
  int val=-1, i, j, flg=0;
  char ch, errPara[2];
  for(i=0;((ch=pm[i])|32)!=32;i++){
     for(j=0;fmt[j];j++)
	if(ch==fmt[j]){
		if(val<0)val=0;
		val|=1<<j; break;
		}
	if(fmt[j]==0){	flg=1;
		*errPara=ch; errPara[1]=0;
		ErrInfo(44,errPara);
		}
	}
  return flg? -1:val;
}

arglists *fixPdPara(int n,char **argv, const ProcOpt *opt1, const ProcOpt *opt2, const int *val, un_Int *para)
{/* fsp_dir para */
  static const un_Int prepara[pd_param_cnt]={  0, 10, 4, 1, 3 };
  int i, tmp;
  arglists *lst;
  memset(opt1->rtval, 0, sizeof(int)*opt1->argc);
  memset(opt2->rtval, 0, sizeof(int)*opt2->argc);
  if( !(lst=procParas(n, argv, opt1, opt2)) )return NULL;
  if(lst->argc==0){
	fspHB(I_None_60, True);
	argsFree(lst);
	return NULL;
	}
  memcpy(para, prepara, sizeof(prepara) );
  for(i=0; i<opt1->argc; i++)
      if(opt1->rtval[i]){ 
	if(opt1->rtval[2])
		switch(i){
		case 0 : msgShow("\"--zero(-z)\" is not useful because dir-type is #base");
			continue;
		case 1 : msgShow("\"--type(-t)\" is not useful because dir-type is #base");
			continue;
		}
	else if(i==3/* -e */){
		msgShow("\"--empty(-e)\" only use #base-dir");
		continue;
		}
	*para|=val[i];
	}
  for(i=0; i<opt2->argc; i++)
     if( opt2->rtval[i] )
	switch(i){
	case 0 : if((tmp=cvtPara(lst->subarg->argv[i], "rwho"))>-1)para[4]=tmp&16 ? 0 : tmp;
	case 4 :	break;
	default : para[i]=atoi(lst->subarg->argv[i]);
//	case 1 : 	case 2 :	case 3 : 
	}
  return lst;
}

const char TypeChr[]="csilbwudBWUDnmvtyf";
/* 0-11 _Int; must do CASE
12 None( no write any to DAU )
13 用于输入带0的字串，m后是分隔符，将被0取代。
14 'v' no-cvt-data(void type);
15 't' normal-strings(Text), cvt "\r\n"=>"\n";
16 'y' like 't', but free input, cut 2 side CHAR(13,10,32,9), only use Sold
17 file(load one file into);
*/
char ErrParam;
int fixType(BYTE *T, int n,int cnt, char ch, char extparm)
{
int t;
for(t=0;t<TypeCount && ch!=TypeChr[t];t++);
if(t<TypeCount){
	T[n]=t;
	if(t==_separa)T[cnt+n]=extparm;
	}
else {
	ErrParam=ch;	DefaultManu(39);
	}
return t;
}

int comExtPara(char *extparm,BYTE *types, int *preLens, int cnt,BYTE defauType)
{/* TYPE & MODE in command ext-parm, it must adjust all error,
so can't div func */
int mode=0;
if(types)memset(types, defauType, cnt);
if(extparm){
char ch, ic, intbuf[32];
int j, i=0, t=0, n=0, p=0;
while(/*i<47&&*/ (ch=extparm[i])!=32&&ch){
  if(t!=_separa&&ch!='.'&&(ch<48||ch>57))
      switch(ch){
      case '-' : mode = 16; break; // no any mode
      case 'o' : mode |= FSP_OEM /*8*/; break;
      case 'h' : mode |= FSP_MH; break;
      case 'r' : mode |= FSP_MR; break;
      case 'w' : mode |= FSP_MW; break;
      case 'a' : if(preLens==NULL)break;
	j=0;
_re_:	ic=extparm[++i];
	if(ic>47&&ic<58){
		intbuf[j++]=ic;
		goto _re_;
		}
	if(j>0){
		intbuf[j]=0;
		preLens[p++]=atoi(intbuf);
	}
	continue;
      default :	if(types)t=fixType(types, n++, cnt, ch, extparm[i+1]);
	}
  i++;
}
}
return mode ? (mode==16 ? 0 : mode) : 3;  /* default is 1|2 => RW */
}

int pagemore;
void pageMore(void)
{
static int ScrLk;
if(getMsg==NULL&&pagemore){
  if(ScrLk++>21){
	printf("--- more ---"); ScrLk=0;
	char bu[8];
	fgets(bu,7,stdin);
	puts(SPC);
	}
}
}
