/*
  Write & edit by Linjianghua 2004-2006
  Free under LGPL
*/

#include "fspio.h"
#include "rebuild.h"

StrList fspPaths;

fsp_lib *fspAlloc(int n)
{
fsp_lib *rtl=(fsp_lib *)zalloc(sizeof(fsp_lib)+n*sizeof(ZeroCache));
rtl->CurDir=(fsp_dir *)rtl;
rtl->lib=rtl;

return rtl;
}

const char ExtFSP[]=".fsp";
BYTE  fspCtrl[headblockSize];
fsp_lib *fspOpen(const char *filenam, int msg)
{
if(filenam){
 const char *oldfnm=filenam, *rc;
 BYTE *_ctrl=fspCtrl;
 fsp_lib *lib;
 BOOL dect=msg&DectName;
 FILE *pff;
 idxdscpt=0x7fff;
 ropen: pff=dect ? fopen64(filenam,"rb+") : pathopen(filenam,R_OK|W_OK, &rc, &fspPaths);
 if(pff){
     if(fread(_ctrl,1,headblockSize, pff)<headblockSize ||
	strcmp((const char *)_ctrl, (const char *)FileFmt)){
	idxdscpt=1;	fclose(pff);
	if(!dect)free((void *)rc);
	else return NULL;
	goto Re_Open;
     }
   }
   else {
     if(idxdscpt>0x7ffd)idxdscpt=0;
     if(dect)return NULL;
     Re_Open: if(oldfnm==filenam&&memstr(oldfnm,0, ExtFSP, sizeof(ExtFSP), 0)==NULL){
	    filenam=catstr(oldfnm,ExtFSP,0);
	    goto ropen;
	  }
	skpexit: if(filenam!=oldfnm)free((void *)filenam);
/*	if(lib)free(lib);*/
	return NULL;
   }
   lib=fspAlloc(_ctrl[fmt_CtrlSize+1]);/* mem alloc */
   lib->fpt=pff;
   if(fread(&lib->mode, _ctrl[fmt_CtrlSize],1,pff)<1){ idxdscpt=3; goto skpexit; }
/*   lib->ver1=_ctrl[prognamLen+1];
   lib->ver2=_ctrl[prognamLen+2];
   lib->ver3=_ctrl[prognamLen+3];
   lib->CtrlSiz=_ctrl[fmt_CtrlSize];
  lib-zcachsiz=_ctrl fmt_CtrlSzie+1]*/
   memcpy(&lib->ver1,_ctrl+prognamLen+1, 5);
   lib->Num_FCU_Len=getLenght((fsp_dir *)lib);
   struct stat st;
   fstat(pff->_fileno, &st);
   lib->fsz=st.st_size;
//    lib->zcachsiz=pms[pd_param_cnt];
//   lib->zcache=(ZeroCache *)zalloc(lib->zcachsiz*sizeof(ZeroCache));
   if(oldfnm!=filenam)free((void *)filenam);
   if(!dect)lib->fname=rc;
   idxdscpt=0x7fff;/* clear it for scriptfile */
   if((msg&FastBuf)==0)setbuf(pff, NULL);
   return lib;
 }
 else return NULL;
}

void fspClose(fsp_lib *lib,fsp_lib* (*Compr)(fsp_lib *,const char *,int))
{
if(lib){
    while(lib->cnt_usedir>0)
	pd_close(lib->usedirs[0], 0);
    if(lib->mdf){
      if(Compr){
	unsigned int sz=lib->fsz-lib->useSize;
	if(sz > lib->CmprSiz*1024 &&
		( sz>0xffffff ? sz/(lib->fsz/100) : (sz*100/lib->fsz) ) > lib->cmprPer)
		lib=Compr(lib,NULL, ShowTips /* show "fspRebuild..." */ );
	}
      if(lib->mdf&127)fspTime(0, lib->datebuf); /* 128(OnlyChDir) no chtime */
      dkwrite(lib,headblockSize-1, &lib->zcachsiz, lib->ctrlSiz+1);
    }
    if(lib->fname)free((void *)lib->fname);
    fclose(lib->fpt);
    free(lib);
  }
}
