/*
	Designed & modify by (Xempo)Linjianghua
	Free under LGPL
*/

#include <float.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define fcn			12

#define	stricmp	strcasecmp

double ln(double d)
{
return log10(d)/log10(M_E);
}

double ctg(double d)
{
return 1/tan(d);
}

double actg(double d)
{
return (M_PI_2-atan(d));
}

int n_CalcErr;
char Calcfunc[36];/* store error mathfunc-name */
double (*mfun[fcn])(double d)={sin,cos,tan,ctg,log10,ln,asin,acos,atan,actg,exp,fabs};

#define	sym_M_E		255
#define	sym_M_PI	254
#define	sym_Backup	253
double db_syb(unsigned char *pch, double *bk, unsigned int *i)
{
int  jao=0;
double db;
if(*pch=='@'){ (*i)++; pch++; jao=1; }
switch(*pch){
case sym_M_E : db=M_E; break;
case sym_M_PI : db=M_PI; break;
case sym_Backup : (*i)++; db=bk[ pch[1] ]; break;
default : db=atof((const char *)pch);
}
return jao ? db * M_PI/180: db;
}

#define CalcOp		7
const char MathSyb[6]={ '(', ')', '[', ']', '{', '}' };
const char CalcChs[CalcOp]={ '_', '^', '*', '/', '%', '+', '-' };
double calc(const char *ExprChs)
{
static const unsigned char fun[fcn][5]={"sin","cos","tag","ctg","lg","ln",
	"asin","acos","atag","actg","exp","abs"};
static const int cchslen[3]={2,3,2}, begin[3]={0,2,5};
double  *bk, rc, db1
#ifndef		_STDIO_H
, *db;
int  *sybpos
#endif
;
unsigned int t, i, j, c, a;
int x, y, b, d, *mvdb, 
 w=1, v=1, f=0, ErrNo=0;
char syb, syb2, C;
unsigned char *bu, *symbuf
#ifndef		_STDIO_H
, *chs;
#define		Cal_Lmt		64000
#else
;
#define		Cal_Lmt		2000000
#endif

if(!ExprChs || !*ExprChs || (t=strlen(ExprChs)+1)>Cal_Lmt ){
	n_CalcErr=0;
	return 0;
	}
/* because rc=0 is x87,  so use return, smaller size */

#ifdef	_STDIO_H
unsigned char chs[2*t];  /* gcc */
#else
chs=(unsigned char *)malloc( 2*t );  /* TC */
#endif
bu=chs;	symbuf=chs+t;

for(i=0, j=1; i<t; i++) /* 0 must send to chs, so t...+1 */
  if((C=ExprChs[i])!=32&& C!=9 ){/* ѹ */
	syb2=ExprChs[i+1]|32;
 	if((syb=C|32)=='e'&&(syb2<97||syb2>122))*bu=sym_M_E;
 	else if(syb=='p'&&syb2=='i'){ *bu=sym_M_PI; i++; }
	     else { *bu=C;
		  if(C=='('||C=='['||C=='{')j++;
		  else for(b=0;b<CalcOp;b++)if(CalcChs[b]==C){ w++; break; }
		}
	bu++;
  }
#ifdef	_STDIO_H
double db[w+j];  /* gcc	*/
int sybpos[j*sizeof(int)];
#else
sybpos=(int *)malloc( j*sizeof(int) + sizeof(double)*(w+j) );/* TC	*/
db=(double *)(sybpos+j);
#endif
bk=db+w;
for(x=0;x<5;x+=2){
 for(y=0;chs[y]/* no change this,it would change len in follow */;y++){
 if(chs[y]==MathSyb[x])sybpos[f++]=y;
 if(chs[y]==MathSyb[x+1]){
   if(f--<1){ ErrNo=5011+x; goto calcEnd; }
   w=sybpos[f];
   bu=chs+w+1; chs[y]=0;
CalcRun:	for(syb=1,i=0;bu[i]=='-'||bu[i]=='+';i++)
		if(bu[i]=='-')syb=-syb;
 *db=db_syb(bu+i,bk,&i)*syb;
 for(t=0;bu[i];i++){
   switch(bu[i]){ /* process bu string */
   case sym_M_E :
   case sym_M_PI :
   case sym_Backup : syb2=syb; goto skp1;
   default : { syb2=1;
    for(b=0;b<CalcOp;b++)if(CalcChs[b]==bu[i]){
        for(symbuf[t++]=bu[i++];bu[i]=='+'||bu[i]=='-';i++)
		if(bu[i]=='-')syb2=-syb2;
	skp1: db[t]=db_syb(bu+i,bk,&i)*syb2;
		break;
	}
    for(j=0; j<37 && ((C=bu[i])|32)>96&&(C|32)<123; j++,i++) // only 38 chars (limit)
	Calcfunc[j]=j>33 ? '.' : C;

    if(j>0){
	Calcfunc[j]=0;
	db1=db_syb(bu+i,bk,&i);
	for(j=0; j<fcn&&strcmp(Calcfunc,(const char *)fun[j]); j++) ;
	if(j>=fcn){ ErrNo=5010; goto calcEnd; }
	if(db1<=0 && j>2 && j<6){ ErrNo=4997+j; goto calcEnd; }
	db[t] = (*mfun[j])(db1)*syb2;
	}
        }
   }
 }/* finish bu */
for(i=0;i<3;i++){
  for(j=0;j<t;j++)
   for(b=begin[i], d=b+cchslen[i]; b<d; b++)if(CalcChs[b]==symbuf[j])
  {/* math  */
   rc=db[j]; db1=db[j+1];
   switch(symbuf[j]){
   case '_' : if(rc==1||rc<=0||db1<=0){ ErrNo=5003; goto calcEnd; }
		rc=log10(db1)/log10(rc); break;
   case '^' : rc=pow(rc,db1); break;
   case '*' : rc*=db1; break;
   case '%' : 
   case '/' : if(db1==0){ ErrNo=5004; goto calcEnd; }
		rc=symbuf[j]!='%'? rc/db1:(long)rc%(long)db1;
		break;
   case '+' : rc+=db1;	break;
   case '-' : rc-=db1;
   }
   db[j]=rc;
   if(t>j+1/*(b1=t-j-1)>0*/){/* double is x87 code, use x86 possible */
	for(a=j; a<t; a++){
		symbuf[a]=symbuf[a+1];
		for(mvdb=(int *)(db+a+1),c=0; c < sizeof(double)/sizeof(int); c++)
		  mvdb[c]=mvdb[c+sizeof(double)/sizeof(int)];
		}
	}
/*  if(t>j+1)for(b1=j;b1<t;b1++){db[b1+1]=db[b1+2];symbuf[b1]=symbuf[b1+1];}*/
   t--;	j--;
  break;
  }   /* end math */
}
if(x>5)goto calcEnd;
bk[v]=*db;
/*scopy(chs+w+2,chs+y+1);*/
for(j=y+1,i=w+2; (chs[i]=chs[j]); i++, j++) ;
y=w+1;
chs[w]=sym_Backup; chs[y]=v++;
  }/*  end ()[]{} if  */
  }/*  end for	*/
if(f){ ErrNo=5011+x+1; goto calcEnd; }
  }/*  end 3 loop for )]}  */
bu=chs;
goto CalcRun;

calcEnd: rc= ErrNo&&*chs==0? 0:*db;
#ifndef	_STDIO_H
free(sybpos); free(chs); /* TC	*/
#endif
n_CalcErr=ErrNo;
return rc;
}


