/*
	write & edit by LinJiangHua (xempo) 2011-2
	copyright LinJiangHua
*/

#include <sys/socket.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <dirent.h>
#include <utime.h>
#include <qtooltip.h>
#include "filesan.h"
#include "../rtdata/en/target/filesor.h"
#include "xfunc.h"
#include "fileatt.h"
#include "copypanel.h"
#include "searchmodify.h"

#define		MAXALLOC	0x20000

QStringList copyInfoList;

void *doCopy(void *pm)
{
((CopyThread *)pm)->run();
return NULL;
}

void logRecorde(QStringList &msgList, const char *txt)
{
msgList.append( QDateTime::currentDateTime().toString(QString::fromUtf8(txt)) );
}

void size_count(unsigned int len)
{
	copySize+=len;
	if( copySize > 1024*1024 ){
		cpSzM+=copySize/(1024*1024); copySize=copySize%(1024*1024);
	}
}

void saveLog(const char *logNam, QStringList &msgList)
{
FILE *fp;
struct stat64 st;
int i, sz, est;
est=stat64(logNam, &st);
if(fp=fopen(logNam, est ? "w":"rb+")){
  if(est==0){
	if( (sz=st.st_size)> 1024*1024 ){
	  char *pt, *buf=(char *)malloc(sz+2);
	  fread(buf, sz, 1, fp);
	  buf[sz]=0;
	  rewind(fp);
	  if( (pt=strstr(buf, "\n\n")) )pt+=2;
	  fwrite(pt, sz-(pt-buf), 1, fp);
	  free(buf);
	}
	else fseek(fp, 0, SEEK_END);
	}
  QString s;
  for(i=0; i<msgList.count(); i++)s+=*msgList.at(i)+"\n";
  sz=strlen(s.utf8());
  fwrite( s.utf8(), sz, 1, fp);
  if(est==0)ftruncate(fp->_fileno, ftell(fp));
  fclose(fp);
}
}

QPtrList <CopyThread> copy_thr;
CopyThread::CopyThread(QWidget *w, Filesan *f, FastBlock &s, const char *d, int m) : // QThread(PTHREAD_STACK_MIN*40),
	wdg(w), fs(f), srcLst(s), codec(f->vStrCodec), isPop(0),
	_dst(strdup(d)), runCp(99), cpMode(m), CopyTag(SkipCopy), SymCvtDir(SymNo), ExistedSymlnk(Exist_Sym_Skip),
	szM(0), size(0), cpCnt(0), cpDone(0), it(NULL), tsz(0), csz(0), retm(0), cursrc(NULL), curdst(NULL)
{
copyThreadCount++;
fs->vNotifyTM=3; // sure display ...
if(cp_tm<=0){
	time(&cp_tm);
	copyResult=0;	copyMode=m;
	copiedTimes=0;
	copySize=0; cpSzM=0;
	}
else if(copyMode!=32&&copyMode!=35)copyMode=m;

copy_thr.append(this);
memset(s_errorback, 0, sizeof(int)*128);
memset(d_errorback, 0, sizeof(int)*128);
cpInfoList.append(strCodec->toUnicode(srcLst.bufferString(';')) );
cpInfoList.append(QString::fromUtf8(copyToChs));
cpInfoList.append(strCodec->toUnicode(d));
logRecorde(cpInfoList, startChs);
srcLst.memDiv(";");
//start(); // IdlePriority

	pthread_t thr;
	pthread_attr_t attr;
	pthread_attr_init( &attr );
	pthread_attr_setschedpolicy(&attr, 1);
	pthread_attr_setstack(&attr, malloc(PTHREAD_STACK_MIN*40), PTHREAD_STACK_MIN*40); 	// 16k+1024
	pthread_create(&thr, &attr, doCopy, this);
}

char *copyInfo(int m, int rclt, int mSz, int sz, int take)
{
char takebuf[56], *bu=(char *)malloc(256);
int n=sprintf(bu, cpResultChs, _filesor_[m-32], rclt, mSz, sz);
if(take>60)sprintf(takebuf, takeChs, take/60, take%60);
else sprintf(takebuf, takeChs0,  take);
scopy(bu+n, takebuf);
return bu;
}

CopyThread::~CopyThread()
{
if(cpDone>0){
	time_t tm;
	time(&tm);
	int SzM, Sz;
	if( csz > 1024*1024 ){
		SzM=csz/(1024*1024); Sz=csz%(1024*1024);
	}
	else { SzM=0; Sz=csz; }
	char *info=copyInfo(cpMode, cpCnt, SzM, Sz, tm - th_take);
	cpInfoList.append( QString::fromUtf8(info) );
	free(info);
}
free((void *)_dst);
if(curdst){
	free((void *)curdst);	free((void *)cursrc);
	}
if(cpInfoList.count()>5){
  QApplication::beep();
  logRecorde(cpInfoList, endChs);
  copyInfoList+=cpInfoList;
  appPost(65121, NULL, fs);
}
if(cpDone>0&&/*pms_copyLog*/__params[52]){
	char *fn=catstr(pluzonecwd, "cpCount.log",'/');
	cpInfoList.append("\n"); // \n\n is separator
	saveLog(fn, cpInfoList);
	free(fn);
}
}

int CopyThread::cp_postInfoWidget(const char *dst, int id, const char *cap)
{
int rt;
time_t tm, tm1;
isPop=1;
time(&tm);
rt=postInfoWidget(ptWdg(), CopyQuest, dst, id, cap);
time(&tm1);
retm+=tm1-tm;
isPop=0;
return rt;
}

struct cpparam {
CopyThread *cpthr;
int idx;
};

void CopyThread::cp_postErrInfo(const char *txt, const char *cap)
{
time_t tm, tm1;
isPop=1;
time(&tm);
postErrInfo(ptWdg(), CopyQuest, txt, cap);
time(&tm1);
retm+=tm1-tm;
isPop=0;
}

void CopyThread::sizeCount(unsigned int rn)
{
    size+=rn;
    csz+=rn;
    if( size > 1024*1024 ){
	szM+=size/(1024*1024);
	size=size%(1024*1024);
	}
}

#define isSelf(dst, src) ( strstr(_dst, src)==dst && strlen(src)==strrchr(_dst, '/')-_dst )

void *countSz(void *cpthr)
{
cpparam *pms=(cpparam *)cpthr;
pms->cpthr->countSize(pms->idx);
free(pms);
return NULL;
}

QWidget *CopyThread::ptWdg()
{
if( wdg && wdg!= (QWidget *)fs ){
	((SearchModify *)wdg)->setEvent();
	return wdg;
	}
return fs;
}

void CopyThread::countSize(int msg)
{
int info, i=msg<0 ? 0 : msg;
char *src;
struct stat64 s_st;
while( i<srcLst.count() ){
	  src=srcLst.lstIndex(i);
	  info=stat64( src, &s_st );
	  if(info||is_dev(s_st.st_mode))tsz+=32;
	  else if(S_ISDIR(s_st.st_mode))procDir(cpMode==FDUP ? COUNT_SIZE_FDUP : COUNT_SIZE, src, NULL);
	          else {
		unsigned long long sz=s_st.st_size;
		lstat64(src, &s_st); // now, s_st.st_size is lnkpoint
		tsz+= S_ISLNK(s_st.st_mode)&&cpMode!=FDUP  ? s_st.st_size : sz;
	}
if(msg>-1)break;
i++;
}
}

void CopyThread::run()
{
 time(&th_take);
 int i, result=0, info, mvdup, L;
 bool creat_lnk, isLink;
 char *chs, *src, *pIdx;
 struct stat64 s_st;
 unsigned long  _cpSzM , _copySize;
 if(cpMode!=FMOVE&&cpMode!=FLINK){
	cpparam *pms=(cpparam *)malloc(sizeof(cpparam));
	pthread_t th;
	pthread_attr_t attr;
	pthread_attr_init( &attr );
	pthread_attr_setstack(&attr, malloc(PTHREAD_STACK_MIN*36), PTHREAD_STACK_MIN*36);
	pms->cpthr=this; pms->idx=-1;
	pthread_create(&th, NULL, countSz, pms);
	}
  OverFileAsDir=OF_No;

  for(i=0; i<srcLst.count()&&result!=opera_cancel&&runCp>-1; i++){
      cpPreCount=srcLst.count()-i;
      src=srcLst.lstIndex(i);
      L=strlen(src);
      if(strstr(_dst, src)==_dst && (_dst[L]=='/'||_dst[L]==0) ){ // isSelf(_dst,src)
	char buff[ L+strlen(_dst)+40 ];
	sprintf(buff, "%s  To\n  %s !", src, _dst);
	cp_postInfoWidget(buff, selCopy);
	continue;
	}
      else {
	mv2cp=false;
	pIdx=strdup(strrchr(src, '/')+1);
	chs=catstr(_dst, pIdx, '/');
	if(strcmp(chs,src)==0){
_reChkNam_:	if(access(chs, F_OK)==0){
			free(chs);
			if(cpMode==FMOVE)continue; // because add_select
			char *fn=pIdx;
			pIdx=catstr("new", pIdx, '_');
			free(fn);
			chs=catstr(_dst, pIdx, '/');
			goto _reChkNam_;
		}
		free(pIdx);
	}
	_copySize=copySize;
	_cpSzM=cpSzM;
	if( lstat64(src, &s_st) /*|| isReadable(uId, gId, s_st)==false */ )
		cp_postErrInfo(src, copyError); // none ... 
	else {
		int lost, w;
		if(panelStatus==0){
			panelStatus=2;
			appPost(65119, NULL, ptWdg());
		}
		isLink=S_ISLNK(s_st.st_mode);
		creat_lnk=(cpMode!=FDUP && isLink );
		result=0;	info=-1;
		
		if(isLink){
			w=isWritable(uId, gId, &s_st);
			lost=stat64( src, &s_st );  // is Dir or file (get)
		}
		cp_IsDir=lost ? false : S_ISDIR(s_st.st_mode);
		if(cpMode==FMOVE){
			if(isLink){
				if(w==false)goto _mv_err_;
			}
			else if(access(src, W_OK)){
			_mv_err_: cp_postErrInfo(src, cp_IsDir ? dmvErr : fmvErr);
				continue;
			}
		}
		if(access(chs, F_OK)==0 && access(chs, W_OK)){
			cp_postInfoWidget(chs, noRightWrite);
			goto _skipcopy_;
		}
		cpDone++; copiedTimes++;
		switch(cpMode){
		case FLINK :
		do_lnk:	if( (result=symlink(src, chs))!=0){ // only  -1
				if( errno!=SYM_EXIST )cp_postErrInfo( chs, symError);
				else if( CopyTag==AutoSkipCopy)goto _skipcopy_;
				     else if(CopyTag!=AllCopy){
					result=0; // recover for skip
					CopyTag=cp_postInfoWidget(chs, symlnkObjExisted );
					switch( CopyTag ){
					case SkipCopy :
					case AutoSkipCopy : goto _skipcopy_;
					case CancelCopy : free(chs); goto _brkcopy_;
					case SureCopy :
					case AllCopy : overlnk:// fs->DelTag=AllDel;
//					postDel(); start
					int ret;
					time_t tm, tm1;
					isPop=1;
					time(&tm);

					del_params *delpms=(del_params *)malloc(sizeof(del_params));
					delpms->hold=true;	delpms->fn=chs;
					appPost(65109, delpms, ptWdg());

					while(delpms->hold)usleep(1000); // wait ...
					ret=delpms->ret;
					free(delpms);
					time(&tm1);
					retm+=tm1-tm;
					isPop=0;
					if(ret)break;
//					postDel(); end
					goto do_lnk;
					}
					}
					else goto overlnk;
			}
			creat_lnk=true;
			break;
		case FMOVE  : 
			if( (mvdup=access(chs, F_OK))==0 || (info=rename( src, chs )) ){
				cpparam *pms=(cpparam *)malloc(sizeof(cpparam));
				pthread_t th;
				pthread_attr_t attr;
				pthread_attr_init( &attr );
				pthread_attr_setstack(&attr, malloc(PTHREAD_STACK_MIN*36), PTHREAD_STACK_MIN*36);
				pms->cpthr=this; pms->idx=i;
				pthread_create(&th, NULL, countSz, pms);
				mv2cp=true;	goto _cp_;
				}
			else copyResult++;
			break;
		default : _cp_: if( creat_lnk )result=SymLink(src, chs);
			     else result =cp_IsDir? procDir(cpMode!=FMOVE? cpMode : FCOPY, src, chs ) : fileCopy( (cpMode!=FMOVE? cpMode : FCOPY), src, chs);
				// result=0 copy, 1 overwrite, 2 no need copy; 4 no right
				// 错：-1 cancel , -2  error; -3 ignore this dircopy ... look copy.h
				//     128 已建了目录的但复制中出错中止，即新建的目录没有复制完
			}

		if( result <-4 /*||result>127 */)break;
		else if(result > -1 ){
			if(result==1&&cp_IsDir&&(copySize!=_copySize||cpSzM!=_cpSzM)){
				struct  utimbuf  utm;
				time_t tm;
				time(&tm);
				utm.actime=tm;
				utm.modtime=tm;
				utime(chs, &utm);
				}
			if(result>127)break;
			if(mv2cp)appPost(65040, strdup(src), ptWdg());
			if( fs->getModul()!=NO_MULT_PANEL&&fs->getModul()!=_FSPLUS ){
				if(stat64(chs, &s_st)==0 && S_ISDIR(s_st.st_mode) ){
					move_params *pm=(move_params *)zalloc(sizeof(move_params));
					pm->src=strdup(src);
					pm->dst=chs;
					appPost(cpMode==FMOVE ? 65112 : 65114, pm, fs);
					continue;
				}
				else if(cp_IsDir && cpMode==FMOVE)fs->getTreeView()->testRemoveDir(src);
			}
		}
_skipcopy_:	free(chs);
	}
	}
   }
_brkcopy_:   // copyFsEnd();
   if(copyThreadCount<2){
	appPost(65107, NULL, fs);
	time_t tm;
	time(&tm);
	take=tm-cp_tm;
	if(copiedTimes>0)appPost(65130, NULL, ptWdg());
	}
//   if( cpCnt &&	( cpSzM || copySize || cpMode==FMOVE ) )appPost(65104, NULL, fs );
copyThreadCount--;
runCp=-2; // end tag
}

int CopyThread::SymLink(const char *src, const char *dst)
{
char *buff;
int  R=0, rt=cp_create, len;
do_lnk: buff=(char *)malloc(8000);
len=readlink(src,buff, 7999);
buff[len]=0;
if(R==0){
  char *tst, *dup;
  if(buff[0] !='/'){
	dup=strdup(src);
	tst=strrchr(dup, '/');
	*tst=0;
	tst=catstr(dup, buff, '/');
	free(dup);
  }
  else tst=buff;
  if(access(tst, F_OK))
	cpInfoList.append( tranText(codec, dst) + QString::fromUtf8(cpLostLink));
  if(tst!=buff)free(tst);
}
R=symlink(buff, dst );
free(buff);
if(R){
	rt=cp_overWrite;
	if(errno!=SYM_EXIST){
		cpInfoList.append(QString::fromLocal8Bit(strerror(errno)) + tranText(codec,dst));
		return (cp_postInfoWidget(dst, questionContinue)==doContinue ? cp_no:opera_cancel );
		}
	else {
		if(CopyTag==AutoSkipCopy|| SymCvtDir==SymAllNo)return cp_no;
		if(CopyTag!=AllCopy&&SymCvtDir!=SymAllOver){
			CopyTag=cp_postInfoWidget(dst, cpPreCount>1 || cp_IsDir ? symlnkObjExisted : symlnkObjExisted3);
			switch( CopyTag ){
			case CancelCopy : return opera_cancel;
			case SureCopy :
			case AllCopy : overlnk: {
				struct stat d_st;
				int lnk1, msg;
				lstat(dst, &d_st);
				if( lnk1=(d_st.st_mode&S_IFLNK) )stat(dst, &d_st);
				if(__params[40]/*updateCopy*/){
					struct stat sst;
					stat(src, &sst);
					if(sst.st_size==d_st.st_size && sst.st_mtime==d_st.st_mtime)return cp_no;
					}
				if( lnk1!=S_IFLNK && (d_st.st_mode&S_IFDIR)==S_IFDIR ){
					if(SymCvtDir==SymAllOver)goto sym_over;
					SymCvtDir=cp_postInfoWidget(dst, cpPreCount>1 || cp_IsDir ? delCvtSymToDir : delCvtSymToDir3);
					switch(SymCvtDir){
					case  SymOver :
					case  SymAllOver : sym_over : // copying=true;
						msg=__operaDir(ptWdg(), TEST_REMOVE_DIR, dst, NULL,NULL); // sm...
						if(msg==0)msg=remove(dst);
						if(msg){
						  cpInfoList.append(QString::fromUtf8(noRightOperaExisted)+dst);
						  return cp_postInfoWidget(dst, noRemoveOrg)!=doContinue ? cp_no : opera_cancel;
						}
						goto do_lnk;
					case SymCancel : return opera_cancel;
					default : return cp_no;
					}
				}
				else unlink(dst);
				goto do_lnk;
				}
				default : return cp_no;
				}
			}
		else goto overlnk;
	}
}
else {
	size_count(len);
	sizeCount(len);
	copyResult++;	cpCnt++;
}
return rt;
}

int chtime(const char *fnam, const struct stat64 *st)
{
	struct  utimbuf  utm;
	utm.actime=st->st_atime;
	utm.modtime=st->st_mtime;
	return utime(fnam, &utm);
}

int CopyThread::adjustCopy(const char *chs, int *errnoback, int id)
{
int i, err_no=errno;
for(i=0; errnoback[i] && errnoback[i]!=err_no; i++);
cpInfoList.append(QString::fromLocal8Bit(strerror(err_no)) + tranText(codec,chs));
if( errnoback[i]==0 ){
	switch(cp_postInfoWidget(chs, id)){ // 4button: continCap, "跳过此目", "忽略此情",cancel_btn
	case 0 : return cp_no;
	case 1 : return opera_cancel;
	case 2 : return cp_ignoreThrow;
	case 3 : for(i=0; errnoback[i]; i++);
		errnoback[i]=err_no;
		// return cp_ignoreStat; // no needed
	}
}
return 0;
}

void CopyThread::safeFreshData(const char *src, const char*dst)
{
const char *tmp;
tmp=cursrc;
cursrc=strdup(src);
if(tmp)free((void *)tmp);
tmp=curdst;
curdst=strdup(dst);
if(tmp)free((void *)tmp);
}

int CopyThread::fileCopy(int cmd, const char *src, const char *dst)
{
// 严重错误才返-5  |  t=0 copy, 1 overwrite, 2 no need copy (lnk); -1 cancel, -2  no  ...  copy.h
int rt=cp_create;
struct stat64 st;
#define  NoLink()  (src_lnk==false||cp_IsDir==false)
safeFreshData(src,dst);
szM=0;	size=0;
if( lstat64(src, &st) /*&& access(src, F_OK) */)
_skp_src_err: return adjustCopy(src, s_errorback, cpPreCount>1 || cp_IsDir ? copyTips:copyTip2);
else {
  char *buff;
  FILE *dfp, *sfp;
  bool isdev, src_lnk, dst_lnk=false;
  struct stat64 dst_st;
//  lstat64(src, &dst_st);
  unsigned long long sz;
  int dst_msg,  sMode=st.st_mode;
  src_lnk=S_ISLNK(sMode);
  if( !NoLink() && cmd!=FDUP)goto _sym_;

  isdev =is_dev( sMode );
  if( !(dst_msg=lstat64(dst, &dst_st) ) ){
	rt=cp_overWrite;
          if( (dst_lnk=S_ISLNK(dst_st.st_mode) ) ){
	if(ExistedSymlnk==Exist_Sym_AllSkip)return cp_no;
	if(ExistedSymlnk!=AllOverCvtFile && ExistedSymlnk!=AllOverSymPoint){
		ExistedSymlnk=cp_postInfoWidget(dst, cpPreCount>1||cp_IsDir ? normToSym : normToSym4);
		switch( ExistedSymlnk ){
		case Exist_Sym_Cancel : goto _cancel_;
		case NO_BTN_ID : // click title's X-box
		case Exist_Sym_Skip :
		case Exist_Sym_AllSkip : return cp_no;
		}
	    }
	}
          else {
	if(CopyTag==AutoSkipCopy)return cp_no;
	if(CopyTag!=AllCopy){
		CopyTag=cp_postInfoWidget(dst, cpPreCount>1||cp_IsDir ? copyOver : copyOver3);
		switch( CopyTag ){
		case CancelCopy :  _cancel_: return opera_cancel;
		case NO_BTN_ID :
		case AutoSkipCopy :
		case SkipCopy : return cp_no;
		default : _test_: if( isdev && unlink(dst) )goto _skp_dst_err;
		}
	}
	else goto _test_;
         }
  }

  if( ! isdev ){
	if( (sfp=fopen64(src, "rb"))==NULL )goto _skp_src_err;	
	}
  else   if( S_ISSOCK(sMode) ){
	struct sockaddr_un adr;
	int sock;
	if( (sock=socket(PF_UNIX, SOCK_STREAM, 0) ) < 0 ){
		cpInfoList.append(QString::fromLocal8Bit(strerror(errno)) + tranText(codec,dst));
		return cp_postInfoWidget(dst, creatSockError)==doContinue ? cp_no:opera_cancel;;
		}
	adr.sun_family=AF_UNIX;
	scopy(adr.sun_path, dst);
	if( bind(sock, (struct sockaddr *)&adr, sizeof(adr.sun_family)+strlen(adr.sun_path)) !=0 ){
		close(sock);
		cpInfoList.append(QString::fromLocal8Bit(strerror(errno)) + tranText(codec,dst));
		return cp_postInfoWidget(dst, creatSockError)==doContinue ? cp_no:opera_cancel;
		}
	close(sock);
	csz+=32;
	goto mdf_tim;
	}
  else  {
	if(mknod( dst, sMode, st.st_dev)){
		cpInfoList.append(QString::fromLocal8Bit(strerror(errno)) + tranText(codec,dst));
		return cp_postInfoWidget(dst, mkdevError)==doContinue ? cp_no:opera_cancel;
		}
	csz+=32;
	goto mdf_tim;
	}
  if(NoLink()||cmd==FDUP)fstat64(sfp->_fileno,&st); /* sMode is incorrect, use lstat() */
  else stat64(src, &st);
  sz = st.st_size;
  if( dst_msg==0 && __params[40]/*updateCopy*/ && dst_lnk==false &&
	( NoLink() &&sz==dst_st.st_size) && st.st_mtime==dst_st.st_mtime){
	rt=cp_noNeed;		csz+=sz;
	goto _close_;
	}

  if( NoLink() ||cmd==FDUP ){
          if(dst_lnk ){
	if( (ExistedSymlnk==OverCvtFile||ExistedSymlnk==AllOverCvtFile)){
		if(unlink(dst)){
			cpInfoList.append(QString::fromLocal8Bit(strerror(errno)) + tranText(codec,dst));
			goto _skp_dst_err;
		}
	}
          }
          if( ( dfp=fopen64(dst, "wb")) ){
	buff=NULL;
	if(sz>0){
	    unsigned int rn, cn=sz<MAXALLOC? sz : MAXALLOC;
	    if( (buff=(char *)malloc(cn)) ){
		_cp_loop_:    rn=fread(buff,1,cn,sfp);
		    if(rn>1){
			if(fwrite(buff,rn,1,dfp)<1){
			cp_postInfoWidget(dst, errorInfo);
			rt=opera_error;	goto _jmp2_;
			}
		    size_count(rn);
		    sizeCount(rn);
		    if( runCp>-1 )goto _cp_loop_;
	   	    }
		copyResult++;	cpCnt++;
		fchmod(dfp->_fileno, st.st_mode );
		if( uId==0 )fchown(dfp->_fileno, st.st_uid, st.st_gid);
	   }
	   else rt=(cp_postInfoWidget(dst, questionContinue)==doContinue ? cp_no:opera_cancel );
	}
	_jmp2_: fclose(dfp);
	if(buff)free(buff);
	if(rt==opera_error||buff==NULL&&sz>0){
		remove(dst);
		goto _closed_;
		}
mdf_tim:	chtime(dst, &st);
	goto _closed_;
        }
        else { 
	_skp_dst_err: dst_msg=adjustCopy(dst, d_errorback, cpPreCount>1 || cp_IsDir ? copyTips:copyTip2);
	if(dst_msg<0)rt=dst_msg;
	_close_ : if( NoLink() || cmd==FDUP )_closed_: if( !isdev )fclose(sfp);
	}
   }
 else _sym_: if(SymLink(src, dst)==opera_cancel)return opera_cancel;
  }
// if(rt==cp_create)copyResult++;
return rt;
}

int  CopyThread::procDir(int Msg, const char *fdirnam, const char *dst)
{
  struct stat64  src_st;
  if( stat64(fdirnam, &src_st) )return adjustCopy(fdirnam, s_errorback, copyTips);
  if( isExecable(uId, gId, &src_st)==false ){
	if(Msg!=COUNT_SIZE_FDUP && Msg!=COUNT_SIZE)cp_postInfoWidget(fdirnam, dirNoExe, NULL );
	return dir_no_exe;
	}
  if( isReadable(uId, gId, &src_st)==false ){
	if(Msg!=COUNT_SIZE_FDUP && Msg!=COUNT_SIZE)cp_postInfoWidget(fdirnam, noRightOpera, NULL );
	return no_Right;
	}
  const char *fnam;
  struct dirent *dire;
  int tag=0, rt2=0;
  char *chs, *dchs;
  DIR *dir;
  int tms, L, D, Info;
   switch(Msg){
   case FCOPY : lstat64(fdirnam, &src_st);
	if(S_ISLNK( src_st.st_mode ))
		return SymLink(fdirnam, dst);
   case FDUP : tms=0;
	safeFreshData(fdirnam, dst);
mk_dir:	if(mkdir(dst, src_st.st_mode)!=0){
	struct stat64 dst_st;
	bool lnk1;
	int errbak;
	tag=1;
	if(tms++ > 0 )goto _err_;
	       errbak=errno;
	       if( lstat64(dst, &dst_st) ){
		errno=errbak;
		_err_: cp_postErrInfo(dst, copyError);
		_out_0:	return -2;
		}
	       lnk1=S_ISLNK(dst_st.st_mode);
	       if( lnk1 ){
			if(stat64(dst,&dst_st))goto rem_sym;
		}

	       if( S_ISDIR(dst_st.st_mode) ){
		 if(CopyTag==AutoSkipCopy)goto _out_0;
		 if(CopyTag!=AllCopy){
		  CopyTag=cp_postInfoWidget(dst, copyOver);
		  switch( CopyTag ){
		  case NO_BTN_ID :
		  case AutoSkipCopy :
		  case SkipCopy : 	goto _out_0;
		  case CancelCopy :
			return opera_cancel;
		  }
		 }
		 if(lnk1){
		 rem_sym:	unlink(dst);
			goto mk_dir;
			}
		}
	       else {
		if(OverFileAsDir==OF_AllNo)goto _out_0;
		OverFileAsDir=cp_postInfoWidget(dst, overFileAsDir);
		switch( OverFileAsDir ){
		case  NO_BTN_ID :
		case  OF_AllNo :
		case  OF_No :	goto _out_0;
		case  OF_Cancel :
			return cp_ignoreThrow; // tag=cp_ignoreThrow/*-3*/;
			// goto _ex_;
		}
		}
	}
	else if( uId==0){
		chown( dst, src_st.st_uid, src_st.st_gid);
		chtime(dst, &src_st);
	}
	D=strlen(dst);
	dchs=(char *)malloc(D+258);
	scopy(dchs, dst);
	if(dchs[D-1]!=ROOT_CH)dchs[D++]=ROOT_CH;
  }
  L=strlen(fdirnam);
  chs=(char *)malloc(L+258);
  scopy(chs, fdirnam);
  if(chs[L-1]!=ROOT_CH)chs[L++]=ROOT_CH;
  dir=opendir(fdirnam);
  while( runCp>-1 && rt2!=opera_cancel && rt2!=cp_ignoreThrow && rt2!=opera_error && ( dire=readdir(dir))!=NULL ){
    fnam=dire->d_name;
    if( ! (fnam[0]=='.' && (fnam[1]==0 ||( fnam[1]=='.'&&fnam[2]==0))) ){
	scopy(chs+L, fnam);
	Info=stat64(chs, &src_st);
	if(Info==0&&S_ISDIR(src_st.st_mode))
		switch(Msg){
		case COUNT_SIZE_FDUP :
		case COUNT_SIZE : procDir(Msg, chs, NULL);
			break;
		case FDUP :
		case FCOPY : scopy(dchs+D,fnam);
			rt2=procDir( Msg, chs, dchs);
		}
	else 	switch(Msg){
		case COUNT_SIZE_FDUP :
		case COUNT_SIZE : if(Info==0&&is_dev(src_st.st_mode)==false)
					tsz+=dire->d_type==DT_LNK&&(Msg!=COUNT_SIZE_FDUP) ? 32 : src_st.st_size;
				else tsz+=32;
			break;
		case FDUP :
		case FCOPY : 
			scopy(dchs+D,fnam);
			rt2=fileCopy(Msg, chs, dchs);
		}
	}
   }
  free(chs);
  if(Msg==FDUP||Msg==FCOPY)free(dchs);
  closedir(dir);
  return rt2!=opera_cancel ? (rt2<0 && tag==0  ? 128 : tag) : opera_cancel; 
}

#include "copypanel.cpp"
