/*
	Write by xempo 9 2014
	Free under LGPL
*/

#include "person.h"
#include "xfunc.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/person.h"

extern const char slot_save[]; // proedit.cpp

Person::Person(QWidget *par, const char *name) :
	QMainWindow(par, name, WDestructiveClose|WType_TopLevel)
{
    setFont(par->font());
}

// Person::~Person(){}

bool Person::exe(const char *cap, int id, int cnt, const char **chs, int img)
{
    const char **_person_=charsFromFSP(9);
    resize(screenWidth*3/4,screenHeight*3/4);
    setCaption( QString::fromUtf8( cap ) );
    setIcon(*pixmapLoad(img));
    tb=new QToolBar("bottom", this, Qt::DockBottom);
    tb->setMovingEnabled(false);
    helpAct=addToolAction(this, tb, helpImg, helpChs, NULL, slot_help, Key_F1, false, false);
    tb->addSeparator();
    saveAct=addToolAction(this, tb, saveImg, saveChs, NULL, slot_save, CTRL+Key_W, false, false);
    saveAct->setEnabled(false);
    sbar=new StatusPanel(tb, sbar_Stocks);

    tb->addSeparator();
    upAct=addToolAction(this, tb, mvupImg, upTo, NULL, slot_up, CTRL+Key_U, false, false);
    downAct=addToolAction(this, tb, mvdownImg, downTo, NULL, slot_down, CTRL+Key_D, false, false);
    tb->addSeparator();
    addAct=addToolAction(this, tb, itemAddImg, addChs, NULL, SLOT(add()), CTRL+Key_A, false, false);
    removeAct=addToolAction(this, tb, itemRemImg, removeChs, NULL, SLOT(rem()), Key_Delete, false, false);
    mdfAct=addToolAction(this, tb, genSetImg, mdfChs, NULL, SLOT(mdf()), Key_F2, false, false);
    tb->setStretchableWidget(sbar);

    vlist=new ListContent(this, personListChs, id, (Filesan *)parentWidget());
    vlist->setSorting(-1);
    vlist->setRootIsDecorated(true);
    setCentralWidget(vlist);
    connect(vlist, sig_chsel, this, slot_chsel);
    connect(vlist, sig_doRen, this, slot_doRen);
    connect(vlist, sig_enter, this, slot_vEnter);
    for(int i=0; i < cnt; i++)
	vlist->addColumn(QString::fromUtf8(chs[i]) );

    sbar->showMsg(countChrs, 99, false);
    free((void *)_person_[0]);
    free((void *)_person_);
    return true;
}
