/*
	Write by xempo 2014
	Free under LGPL
*/

#include <qtextbrowser.h>
#include "fileatt.h"
#include "searchmodify.h"
#include "../rtdata/en/target/fileatt.h"
#include "fsptime.h"

QPtrList <FileAtt> attWdgs;

const char FileAttirb[]="FileAtt";

#define  _fileatt_  _setting_

FileAtt::FileAtt(QWidget *par, struct fAttribRslt *attr)
	: SettingWidget(par, FileAttirb), fattr(attr)
{
fattr->wdg=par;
attWdgs.append(this);
}

FileAtt::~FileAtt()
{
attWdgs.remove(this);
delete fattr; // alse delete sels
}

static const char sig_return[]=SIGNAL(returnPressed());
void FileAtt::execu(const int w, const int h, const int id)
{
#define  hg  23
#define  fnt_sz  fntSz
int i, g, t, hp, B, W, editH=fntSz*3/2;
struct stat64 stbuf, *st;
char *pt, *buf, *brwtxt;
const char *dscpt;
SettingWidget::execu(w,h,id);
creatGenTab()
buf=(char *)malloc(8192);
setIcon(*pixmapLoad(attribImg));
fname=fattr->fn;
tmp=strdup(fname);
pth=tmp;
lstat64(fname, &stbuf);
if(fattr->lostLnk){
	st=&stbuf;
	dscpt="<font color=#b50000> <u> Lost link </u> </font><br/>";
	isLnk=0;
	}
else {
	const char **p_fileType=_fileatt_+Int_fileType;
	st=&fattr->sb;
	M=st->st_mode;
	isLnk=S_ISLNK(stbuf.st_mode);
	if(S_ISDIR(M)){
		i=1;
		if((t=subDirCount(fname))>-1)
			sprintf(buf, "%s  %d Units ", p_fileType[1], t);
		else sprintf(buf, "%s  disreadable", p_fileType[1]);
		}
	else if(isLnk){
		i=2;
		sprintf(buf, "%llu %s(%llu)",
			st->st_size, p_fileType[2], stbuf.st_size);
		}
	    else if(S_ISCHR(M))i=3;
	         else if(S_ISBLK(M))i=4;
	             else if(S_ISFIFO(M))i=5;
		    else if(S_ISSOCK(M))i=6;
		        else {
			i=0;
			sprintf(buf, "%llu %s", st->st_size, p_fileType[0]);
			}
	dscpt=catstr("<font color=#1c801e>Type : </font>", i<3 ? buf : p_fileType[i], 0);
}
fId=st->st_uid;	gId=st->st_gid;
pt=strrchr((char *)pth, '/');
if((i=strlen(pth))>1){
	if(pt!=pth)*pt=0;
	else pth="/";
	_name=pt+1;
	}
else _name=pth;
edt1=new QLineEdit( tranText(strCodec, _name), tab1);
connect(edt1, sig_return, this, SLOT(namReturn()) );
QDateTime  mdt, adt;
mdftim=st->st_mtime;
mdt.setTime_t(mdftim);
adt.setTime_t(st->st_atime);
QLabel *lab=new QLabel(QString::fromUtf8(lastmdfChs), tab1);
chtm=new QLineEdit(mdt.toString(dtfmtlst.lstIndex(dtfmtCombIdx)), tab1);
connect(chtm, sig_return, this, SLOT(timReturn()) );
if(fattr->lostLnk)goto _setTmOnly_;
if( isWritable(fId, gId, st) ==false){
	edt1->setReadOnly(true);
_setTmOnly_:	chtm->setReadOnly(true);
	}
edt1->setGeometry( hg, fnt_sz, tabw-2*hg, editH );
t=scalefloat(80);
lab->setAlignment( int( QLabel::AlignCenter ) );
lab->setGeometry(hg, editH+fntSz*3/2, t, editH );
chtm->setGeometry( hg+t+1, editH+fntSz*3/2, tabw-2*hg-t-1, editH );
//	if(focus){ edt->setFocus(); edt->selectAll(); }
if(isLnk||fattr->lostLnk){
	settingLab=new QLabel(isLnk? "<font color=#000098>Link :</font>" : "<font color=#b50000>Lostlink :</font>",tab1);
	settingLab->setGeometry(hg, tabh-fnt_sz*5-editH-fnt_sz/2, tabw-2*hg, editH );
	lnkdata=(char *)malloc(8192);
	i=readlink(fname, lnkdata, 8191);
	lnkdata[i]=0;
	lnkedt=new QLineEdit( tranText(strCodec,lnkdata), tab1);
	connect(lnkedt, sig_return, this, SLOT(lnkReturn()) );
	lnkedt->setGeometry(hg, tabh-fnt_sz*5, tabw-2*hg, editH );
	}
pt=catstr("<font color=#102099>Path : </font>" ,  i>1 ? pth : "<font color=#850809>Root</font>", 0);
brwtxt=catstr(pt, "<br/><br/>", 0);
free(pt);
pt=catstr(brwtxt, dscpt, 32);
if(!fattr->lostLnk)free((void *)dscpt);
free(brwtxt);	free(buf);
brwtxt=catstr(pt, "<br/><br/>", 0);
free(pt);
pt=catstr(brwtxt, ddtt, 0);
free(brwtxt);
brwtxt=catstr(pt, adt.toString(dtfmtlst.lstIndex(dtfmtCombIdx)).utf8(), 0);
QString s(QString::fromUtf8(brwtxt));
free((void *)pt);	free(brwtxt);
if(fattr->pExt){
	s+=QString::fromUtf8(disksumm)+QString::fromLocal8Bit(fattr->pExt);
	free(fattr->pExt);
	}
QTextBrowser *brow=new QTextBrowser(tab1);
brow->setGeometry( hg, 2*editH+fntSz*2, tabw-2*hg,
	tabh-(2*editH+fntSz*2)-fnt_sz-(fnt_sz*2/*tab_height*/) - (isLnk||fattr->lostLnk ? 5*fnt_sz : 0) );
brow->setWrapPolicy(QTextEdit::AtWordOrDocumentBoundary);
brow->setText(s);
const char **p_gCap=_fileatt_+Int_gCap,
	**p_chkCap=_fileatt_+Int_chkCap;
static const  int chkRect[3]={ 20, 112,	202 };
t=3;	hp=fntSz*3/4; /* begin */
B=35*fnt_sz/10;
#define  hSpc  fntSz*4/3
W=tabw-fnt_sz*2;
for(g=-1, i=0; i<attr_chkbox; i++){
	if(++t>=3){ t=0;	g++;
		group=new QGroupBox(tab2);
		group->setGeometry( /*scalefloat(*/fnt_sz, hp, W, B );
		group->setTitle( QString::fromUtf8(p_gCap[g]) );
		hp+=B+15;
	}
	chkBox=new QCheckBox(QString::fromUtf8(p_chkCap[t]), group);
	chk_box[i]=chkBox;
	chkBox->setGeometry( scalefloat(chkRect[t]), hSpc, scalefloat(80), fntSz*3/2 );
	if( fattr->lostLnk)goto _dis_;
	else chkBox->setChecked( ((M>>((2-g)*3))>>(2-t))&1 );
	if(uId && fId!=uId)_dis_: chkBox->setEnabled(false);
}
group = new QGroupBox( tab2 );
pt=logorName(fId, usrIDs, usrList);
FastBlock lst(NoFree);
lst.add(pt);
group->setGeometry( fnt_sz, hp, tabw/2,  tabh-hp- fntSz*(fattr->isDir? 5 : 3) ); // headpage
settingCombo = creatCombo( false, group, NULL, uId ? &lst : usrList, userImg);
settingCombo->setCurrentText(pt);
pt=logorName(gId, groupIDs, grpList);
lst.resetMem(pt);
swComboGroup = creatCombo( false, group, NULL, uId ? &lst : grpList, groupImg );

swComboGroup->setCurrentText(pt);
B=fntSz/2;
t=tabw/2-fntSz;
settingCombo->setGeometry( B, hSpc, t, inputH );
swComboGroup->setGeometry( B, fntSz*5/3+inputH, t, inputH );
hp+=fntSz/3;

for(t=0; t<3; t++){
	super_chk[t]=new QCheckBox(QString::fromUtf8(_fileatt_[Int_supCap+t]), tab2);
	if(fattr->lostLnk)super_chk[t]->setEnabled(false);
	else super_chk[t]->setChecked(((M>>((3)*3))>>(2-t))&1);
	super_chk[t]->setGeometry( tabw/2+2*fntSz, hp, W-tabw/2-fntSz*2-1, fntSz*3/2 );
	hp+=fntSz*2;
	}
if(fattr->isDir){
	subChk=new QCheckBox(QString::fromUtf8(incluSub) , tab2);
	subChk->setGeometry(scalefloat(80), tabh-fntSz*7/2-scalefloat(5), scalefloat(168), inputH );
	subChk->setEnabled( (uId==0 || fId==uId) );
	}

group->setTitle( QString::fromUtf8(  usrGrp ) );
show();

}

QMetaObject *FileAtt::metaObj = 0;
static QMetaObjectCleanUp cleanUp_FileAtt( FileAttirb, &FileAtt::staticMetaObject );
QMetaObject* FileAtt::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "Sure()" , &slot_0_0, QMetaData::Private },
	{ "namReturn()" , &slot_0_0, QMetaData::Private },
	{ "lnkReturn()" , &slot_0_0, QMetaData::Private },
	{ "timReturn()" , &slot_0_0, QMetaData::Private },
    };
    metaObj = QMetaObject::new_metaobject(FileAttirb, QWidget::staticMetaObject(), slot_tbl, 4,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_FileAtt.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool FileAtt::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

inline void Filesan::chFattrib(struct fAttribRslt *fRslt)
{
bool xTag;
LVItem *it1;
int i=-1;
char *pt=fRslt->fn;
changAttrib: 
	if( fRslt->idChMsg )	__operaDir(this, CHIDS, pt, Filter, fRslt);
	if(fRslt->modChMsg )__operaDir(this, CHMODE, pt, Filter, fRslt);
	if(fRslt->tmChMsg)__operaDir(this, CH_TIME, pt, Filter, fRslt);

	if(fRslt->modChMsg||fRslt->idChMsg){
		it1=modul!=NO_MULT_PANEL ? treeview->seekDir(pt, TEST_GETITEM ) : NULL; // perhans _PLACE
		if(it1){
			int mode=getMode(pt, &xTag);
			it1->setPixmap(0, *selectDPix(mode) );
			if( fRslt->chSub|| fRslt->xOld!=xTag || fRslt->rOld!=is_rTag(mode) )freshDirItem(it1);
			treeUpdateObjs(pt);
			}
	      }
	if(fRslt->inView){
		struct stat64 st;
		while( ++i<fRslt->sels.count() ){
		pt=fRslt->sels.lstIndex(i);
		if(strcmp(pt, fRslt->fn)){
			stat64(pt, &st);
			fRslt->isDir=S_ISDIR(st.st_mode);
			goto changAttrib;
			}
		}
	}

	if(fRslt->lastname){
		oldName=fRslt->fn;
		renaming(fRslt->lastname, fRslt->inView, true);
		}
	else free(fRslt->fn);
}

inline void SearchModify::chFattrib(struct fAttribRslt *fRslt)
{
int i;
for(i=0;i<fRslt->sels.count();i++){
	const char *pt=fRslt->sels.lstIndex(i);
	if( fRslt->idChMsg )	__operaDir(this, CHIDS, pt, NULL, fRslt);
	if(fRslt->modChMsg )__operaDir(this, CHMODE, pt, NULL, fRslt);
	if(fRslt->tmChMsg)	__operaDir(this, CH_TIME, pt, NULL, fRslt);
	}

if(fRslt->lastname){
	struct stat64 st;
	LVItem *it=(LVItem *)_vList->currentItem();
	char *fn=fRslt->lastname;
	i=listViewIndex(_vList, it);
	sm_pms[i].mdf=true;
	if(strcmp(it->fnam, fn)==0)free(fn);
	else if(isExist(fn, &st)==0){
		QApplication::beep();
		char *chs=catstr(fn, fnamExist,'\n');
		infoWidget(chs, warnChs, normError, this);
		free(chs);	free(fn);
	  }
	  else if(rename(it->fnam, fn)){
		ErrorQuestion(this, normError, fn, renError );
		free(fn);
		}
	          else {
		free(it->fnam);	it->fnam=fn;
		sm_pms[i].fnam=fn;
		it->setText(0,curCodec()->toUnicode(strrchr(fn,'/')+1));
		chSelect();
		}
	sm_pms[i].mdf=false;
}
tms=18;
}

bool FileAtt::qt_invoke( int _id, QUObject* _o )
{
int i, sw=_id - staticMetaObject()->slotOffset();
switch(sw){
case 3 :
case 2 :
case 1 :
case 0 : int j, g, t, mode;
	char *fnam;
	fnam=strdup(strCodec->fromUnicode(edt1->text()));
	if(strcmp(_name, fnam ))fattr->lastname=catstr(pth, fnam, '/');
//	else fattr->lastname=NULL;
	if(isLnk||fattr->lostLnk){
		QCString s(strCodec->fromUnicode(lnkedt->text()));
		if(strcmp(s, lnkdata)){
			if(unlink(fname)==0)symlink(s, fname);
			else QApplication::beep();
			}
	}
	free(fnam);
	free(tmp);
	if(fattr->isDir)
		fattr->chSub=subChk->isChecked();

	if( fattr->lostLnk==false){
	    if( fId==uId||uId==0){
	    g=0;	j=0;	t=0;	mode=0;
	    for(i=0; i<attr_chkbox; i++){
		j|=(chk_box[i]->isChecked()? 1:0)<<(2-t);
		if(++t>=3){
		    mode|=j<<(2-g)*3;
		    j=0;	t=0;	g++;
		}
	    }
	    for(i=0; i<3; i++)if(super_chk[i]->isChecked())mode|=(0001000)<<(2-i);
	    if(fattr->chSub || mode!=(M&07777) ){
			fattr->mode=mode;
			fattr->modChMsg=true;
		}
	    }
	    time_t tm;
	    struct tm st_tm;
	    smtime(chtm->text(), &st_tm);
	    tm=mktime(&st_tm);
	    if(mdftim!=tm){
		fattr->tmChMsg=true;
		fattr->sb.st_atime=tm;
		fattr->sb.st_mtime=tm;
		fattr->sb.st_ctime=tm;
		}
	    if(uId==0){
		i=usrList->count()-1-settingCombo->currentItem();
		t=grpList->count()-1-swComboGroup->currentItem();
		if( fattr->chSub || fId!=usrIDs[i] || gId!=groupIDs[t] ){
			fattr->idChMsg=true;
			fattr->uid=usrIDs[i];	fattr->gid=groupIDs[t];
			}
		}
	}
	if(isLnk||fattr->lostLnk)free(lnkdata);
	fattr->sels.memDiv(NULL);
	hide(); // if infoWidget(...) in chang...
	if(fattr->inView==2)((SearchModify *)parentWidget())->chFattrib(fattr);
	else ((Filesan *)parentWidget())->chFattrib(fattr);
	close();
	break;
default : return QWidget::qt_invoke( _id, _o );
}
return true;
}
