/*
	Write by xempo 2014-2015
	Free under LGPL
*/

#include <qfontdatabase.h>
#include <qlineedit.h>
#include "genset.h"
#include "../rtdata/en/target/setting.h"

#include "tabwdg.cpp"

extern void createBtns(QWidget *wdg, QPushButton **Btn, const char **btnCap, int btnCount,
	int wd, int yPos, const char **slot1, const int *pix);

// extern const char sigactIdx[]; // xfunc.h
GenSetting *genSetWdg;

const char listSet[]="GenSetting",
	orgFileList[]={ 1,2,3,4,5,6,7,1,1,0,1,0,1,0 };

const QMetaData orgStyleSlot={ "orgStyle()", &slot_0_0, QMetaData::Private };

GenSetting::GenSetting(QWidget *par)
	: SettingWidget(par, listSet), utf8code(_setCodec(2)),
	tashCnt(0), tashPre(0)
{
setFont(par->font());
}

LVItem *GenSetting::subNodeCreat(LVItem *it, LVItem *after, const char *txt, const QPixmap *pix, const QPixmap *pix2, MAU *mau)
{
int D;
FastBlock lst;
lst.getFromMau(mau);
lst.memDiv(":,");
LVItem *ic, *sit=new LVItem(it, after, txt, utf8code);
sit->setType(after ? 2 : 1);
sit->setPixmap(0, *pix);
ic=NULL;
for(D=0; D<lst.count(); D++){
	ic=new LVItem(sit, ic, lst.lstIndex(D), utf8code);
	ic->setType(after ? 4:3);
	ic->setPixmap(0, *pix2);
	ic->setRenameEnabled(0,true);
	}
return sit;
}

TWprg::TWprg(QWidget *p, int idx) : TabWdg(p, idx)
{
}

void TWprg::closing()
{
	int i;
	Filesan *fs=(Filesan *)(topLevelWidget()->parentWidget()), *_fs;
	fs->setProgFonts(comboFont->currentText(), comboSize->currentText(),
		boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked() );
	fs->refreshList(dtfmtlst.lstIndex(dtfmtCombIdx));
	for(i=0; i<filesors.count(); i++){
	     _fs=filesors.at(i);
	     if(fs!=_fs){
		_fs->setProgFonts(comboFont->currentText(), comboSize->currentText(),
			boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked() );
		_fs->refreshList(dtfmtlst.lstIndex(dtfmtCombIdx));
		}
	}
	TabWdg::closing();
}

void GenSetting::execu(const int w, const int h, const int id)
{
#define  LeftWide  64
#define  hg  23
#define   fastHtmBrow  chkBox
#define   proEditDft  subChk
	int t, j, B=scalefloat(18);
	SettingWidget::execu(w,h,id);
	creatGenTab()
	tab3=new TWprg(tabwdg, 51);
	((TabWdg *)tab3)->init(_setting_+Int_feelview, tabw, fntSz, progFontId);
	QWidget *tab4=new QWidget(tabwdg);

	listSetInit(tab4, &optList, scaleRect(60, 26, 218, 228), &upBtn, &downBtn, colOptRslt);
	upBtn->setGeometry(scaleRect(LeftWide+218+18, 26+80, 2*hg, hg+8 ));
	downBtn->setGeometry(scaleRect(LeftWide+218+18, 26+80+3*hg, 2*hg, hg+8 ));

	tabwdg->addTab(tab4, *pixmapLoad(listSetImg), QString::fromUtf8(listset));

	lnkList=new ListContent(tab2, LnkTogListChs, T_LnkTogList, (Filesan *)parentWidget());
	lnkList->setSorting(-1);
	lnkList->addColumn(_Spc);
	lnkList->header()->hide();
	lnkList->setGeometry( B, B, tabw-2*B, tabh-fntSz-scalefloat(86) );
	connect(lnkList, sig_chsel, this, slot_chsel);
	connect(lnkList, sig_doRen, this, slot_doRen);

	static const char *__slots[3]={ SLOT(new()), SLOT(del()), SLOT(mdf())  };
	createBtns(tab2, __Btn, _setting_+Int_addChs, 3, tabw, tabh-4*fntSz-scalefloat(4), __slots, NULL);

	if(FileAssoc){
	 int mode, n=0;
	 MAU mau[3];
	 LVItem *sit, *it=NULL;
	 j=-1;
	 nodCnt=FileAssoc->selfnumbs;	nodPre=nodCnt+6;
	 nodItems=(LnkNode *)zalloc(nodPre*sizeof(LnkNode));
	 while(n < nodCnt&&j<0xffff)
	    if( (mode=numbRead(FileAssoc, ++j, mau,3, false))>-1 ){
		nodItems[n++].num=j;
		it=new LVItem(lnkList, it, mau[2].buf, utf8code);
		it->setType(mode&FSP_OEM); // 8
		it->setPixmap(0, *pixmapLoad(mode&FSP_OEM ? itemOEMImg : itemGenImg));
		if((mode&FSP_OEM)==0)it->setRenameEnabled(0,true);
		it->setOpen(true);

		sit=subNodeCreat(it, NULL, progs, execfile, execfile, mau);
		subNodeCreat(it, sit, filters, pixmapLoad(filterImg), filepix, mau+1);
		}
	 lnkList->setSelected(lnkList->firstChild(), true);
	}
#define  headHeight  20
	settingLab=new QLabel(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(dtfmtlst.lstIndex(dtfmtCombIdx)), tab4);
	settingCombo=creatCombo( false, tab4, "dtfmt", p_dtfmtlst, -1 );
	settingCombo->setCurrentItem( (settingCombo->count()-1) - dtfmtCombIdx);
	connect(settingCombo, sigactIdx, this, SLOT(dtfmtSel()));

	fastHtmBrow=new QCheckBox(QString::fromUtf8(browDft),tab1);
	fastHtmBrow->setChecked(_Params[38]);

	copyLog=new QCheckBox(QString::fromUtf8(copyLogChs),tab1);
	copyLog->setChecked(pms_copyLog);
	
	group=new QGroupBox(QString::fromUtf8(proEditChs), tab1);
	proEditDft=new QCheckBox(QString::fromUtf8(peDft),group);
	proEditDft->setChecked(_Params[39]);
	peBak=new QCheckBox(QString::fromUtf8(peBakChs),group);
	peBak->setChecked(_Params[29]);
	
	delWarn=new QCheckBox(QString::fromUtf8(delWarnChs),tab1);
	delWarn->setChecked(_Params[41]);

	homeUse=new QCheckBox(QString::fromUtf8(reserveChs), tab1);
	homeUse->setChecked(_Params[0]);

	moreShow=new QCheckBox(QString::fromUtf8(moreShowChs), tab1);
	moreShow->setChecked(pms_moreShow);
//	onlyFile=new QCheckBox(QString::fromUtf8(onlyFileChs), tab1);	onlyFile->setChecked(pms_onlyFile);

	move(parentWidget()->x()+(parentWidget()->width()-width())/2,
		parentWidget()->y()+(parentWidget()->height()-height())/2);

	int w1, w2, combH, hSpc;
	j=scalefloat(21);	w1=tabw-scalefloat(42);
	combH=inputH;
	hSpc=combH+scalefloat(4);
	t=scalefloat(25);
	delWarn->setGeometry(t, headHeight, w1, combH);
	homeUse->setGeometry(t, headHeight+hSpc, w1, combH);
	fastHtmBrow->setGeometry(t, headHeight+2*hSpc, w1, combH);
	copyLog->setGeometry(t, headHeight+3*hSpc, w1, combH);
	moreShow->setGeometry(t, headHeight+4*hSpc, w1, combH);
//	onlyFile->setGeometry(t, headHeight+5*hSpc, w1, combH);

	group->setGeometry(j, headHeight+5*hSpc+scalefloat(6), w1, scalefloat(4*hg));
	proEditDft->setGeometry(scalefloat(10), scalefloat(hg), w2=group->width()-scalefloat(12), combH);
	peBak->setGeometry(scalefloat(10), scalefloat(hg*5/2), w2, combH);
	t=optList->geometry().bottom()+fntSz;
	settingLab->setGeometry(j, t+4, tabw-j-8, combH);
	settingCombo->setGeometry(j, t+combH+fntSz-3, w1, combH);

#undef  headHeight
	setIcon(*pixmapLoad(genSetImg));
	show();
}

QMetaObject *GenSetting::metaObj = 0;
static QMetaObjectCleanUp cleanUp_GenSetting( listSet, &GenSetting::staticMetaObject );
QMetaObject* GenSetting::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	upSlot,
	downSlot,
	{ "dtfmtSel()", &slot_0_0, QMetaData::Private },
	{ "Sure()" , &slot_0_0, QMetaData::Private },

	chSelSlot, //4 
	doRenSlot, 

	newSlot, // 6
	{ "mdf()" , &slot_0_0, QMetaData::Private },
	deleteSlot,
	orgStyleSlot
    };
    metaObj = QMetaObject::new_metaobject(listSet, QWidget::staticMetaObject(), slot_tbl, 10,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_GenSetting.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool GenSetting::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool GenSetting::qt_invoke( int _id, QUObject* _o )
{
int i, sw=_id - staticMetaObject()->slotOffset();
LVItem *it;
switch(sw){
case 0 :
case 1 : // Up
	moveListSet(optList, colOptRslt, sw);
	break;
case 2 : dtfmtCombIdx=(settingCombo->count()-1)-settingCombo->currentItem();
	settingLab->setText(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(dtfmtlst.lstIndex(dtfmtCombIdx)));
	break;
case 3 : { // Sure (Ok-button)
	getListOpts(optList, colOptRslt+colOptCnt);
//	i=(settingCombo->count()-1)-settingCombo->currentItem();
	_Params[38]=fastHtmBrow->isChecked();
	_Params[39]=proEditDft->isChecked();
	_Params[29]=peBak->isChecked();
	_Params[41]=delWarn->isChecked();
	_Params[0]=homeUse->isChecked();
	pms_copyLog=copyLog->isChecked();
	pms_moreShow=moreShow->isChecked();
//	pms_onlyFile=onlyFile->isChecked();
	tab3->closing();
	close();
	if(FileAssoc){
		QListViewItem *sit;
		for(i=0; i<nodCnt; i++)if(nodItems[i].mdf){
		QCString s, s1;
		MAU mau[3];
		memset(mau, 0, sizeof(MAU)*3);
		it=lnkList->Index(i);
		sit=it->firstChild()->firstChild();
		while(sit){ s+=sit->text(0).utf8()+":"; sit=sit->nextSibling(); }
		mau->buf=(char *)(const char *)s;	mau->len=s.length()-1;
		sit=it->firstChild()->nextSibling()->firstChild();
		while(sit){ s1+=sit->text(0).utf8()+","; sit=sit->nextSibling(); }
		mau[1].buf=(char *)(const char *)s1;	mau[1].len=s1.length()-1;
		mau[2].buf=strdup(it->text(0).utf8());	// mau[2].len=0;
//		for(int j=0; j<3; j++)mau[j].alen=0;
		numbWrite(FileAssoc, nodItems[i].num<0 ? lastNumb(FileAssoc) : nodItems[i].num, mau, 3);
		free(mau[2].buf);
		}
		for(i=0; i<tashCnt; i++)num_del(FileAssoc, tash[i].num);
	}
	}
	break;
case 4 : { // chSel
	it=(LVItem *)lnkList->currentItem();
	i=it->getType();
	bool b=(i!=1&&i!=2)&&(i&8)!=8;
	for(i=1;i<3;i++)__Btn[i]->setEnabled(b);
	}
	break;
case 5 : it=(LVItem *)lnkList->currentItem();
	while(it->parent())it=(LVItem *)it->parent();
	nodItems[listViewIndex(lnkList, it) ].mdf=true;
	break;
case 8 : {
	LVItem *pIt;
	it=(LVItem *)lnkList->currentItem();
	if(it->getType()==0){
	    i=listViewIndex(lnkList, it);
		if(nodItems[i].num>-1){
		// num_del(FileAssoc,  nodItems[i].num);
		  if(tashCnt>=tashPre){
			tashPre+=6;
			LnkNode *tmp=(LnkNode *)zalloc(sizeof(LnkNode)*tashPre);
			if(tashCnt){
				memcmp(tmp, tash, sizeof(LnkNode)*tashCnt);	
				free(tash);
			}
			tash=tmp;
		  }
		  tash[tashCnt++]=nodItems[i];
		  if(nodCnt-i>1)memmove(nodItems+i, nodItems+i+1, sizeof(LnkNode)*(nodCnt-i-1));
		  nodCnt--;
		}
	    lnkList->takeItem(it);
	}
	else {
		pIt=it;
		while( pIt->parent() )pIt=(LVItem *)pIt->parent();
		i=listViewIndex(lnkList, pIt);
		nodItems[i].mdf=true;
		it->parent()->takeItem(it);
		}
	((Filesan *)parentWidget())->delLVItem(it);
	}
	break;
case 7 :	lnkList->currentItem()->startRename(0); // mdf
	break;
case 6 : {
	LVItem *sit;
	it=(LVItem *)lnkList->currentItem();
	i=it->getType()&7;
	switch(i){
	case 0 : it=new LVItem(lnkList, lnkList->Index(nodCnt-1), "project1");
		it->setPixmap(0,*pixmapLoad(itemGenImg));
		it->setRenameEnabled(0,true);
		sit=new LVItem(it, NULL, progs);
		sit->setType(1);
		sit->setPixmap(0,*execfile);
		sit->setRenameEnabled(0,true);
		sit=new LVItem(it, sit, filters);
		sit->setType(2);
		sit->setPixmap(0,*pixmapLoad(filterImg));
		sit->setRenameEnabled(0,true);
		lnkList->ensureItemVisible(it);
		it->setOpen(true);
		it->startRename(0);
		if(nodCnt>=nodPre){
			nodPre+=6;
			LnkNode *tmp=(LnkNode *)zalloc(sizeof(LnkNode)*nodPre);
			if(nodCnt>0){
				memcmp(tmp, nodItems, sizeof(LnkNode)*nodCnt);	
				free(nodItems);
			}
			nodItems=tmp;
			}
		nodItems[nodCnt].num=-1; // append
		nodItems[nodCnt].mdf=true;
		nodCnt++;
		break;
	case 1 : 
	case 2 : sit=new LVItem(it, NULL, i!=1 ? "*.*" : "prog1");
		sit->setType(i+2);
		goto _skp_;
	case 3 :
	case 4 : sit=new LVItem((LVItem *)it->parent(), it, i!=3 ? "*.*" : "prog1");
		sit->setType(i);
	_skp_:	sit->setRenameEnabled(0,true);
		sit->setPixmap(0, *(i&1 ? execfile : filepix) );
		sit->startRename(0);
//		break;
	}
	}
	break;
default : return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

GenSetting::~GenSetting()
{
if(tashCnt)free(tash);
free(nodItems);
genSetWdg=NULL;
}
