/*
	林江华编写，保留版权，2010年10月
	develop 2012
*/

#include <fcntl.h>
#include <dirent.h>
#include <sys/errno.h>
#include <sys/un.h>
#include <utime.h>
#include <qtextbrowser.h>
#include <qdatetime.h>
#include <qfont.h>
#include <qpixmap.h>
#include <qcursor.h>
#include <qtextcodec.h>
#include "fastblock.h"
#include "libnorm.h"
#include "listcontent.h"
#include "imagefileview.h"
#include "statuspanel.h"
#include "stdfun.h"
#include "xfunc.h"
#include "copy.h"
#include "fspdir.h"
#include "fspio.h"
#include "icon.def"
#include "../rtdata/en/target/filesor.h"
#include "init.h"
#include "fsloop.def"

QTextCodec *strCodec;

const char archNam[]="*.zip,*.gz,*.rar,*.tar,*.bz2,*.cbz,*.jar,*.lzma,*.ar,*.xz,*.rpm",
	*pcwd, *home,
	sigactIdx[]=SIGNAL(activated(int)),
	sigact[]=SIGNAL(activated());

const QPixmap *dirpix, *filepix, *lnkdir, *lnkfile, *filelock, *dirlock, *dirnoExec, *dirnoWrite, *execfile, *archfile, *homedir, *lnklost,
*_dirpix, *_filepix, *_lnkdir, *_lnkfile, *_filelock, *_dirlock, *_dirnoExec, *_dirnoWrite, *_execfile, *_archfile, *_homedir, *_lnklost,
*searching, *searching1, *searching2, *searching3, *fspSpaceIco, *imgWait, *imgWait2;

fsp_lib *fsplib;
fsp_dir *fspRoot, *descript, *FileAssoc, *iconDir, *selfDir;

int *__params, currentCodec;

FastBlock *usrList, *grpList;

void appPost(int T, void *dat, QObject *obj)
{
CustEvents *evnt=new CustEvents(T);
if(dat)evnt->setData(dat);
QApplication::postEvent(obj, evnt);
}

QTextCodec * _setCodec(int code)
{
static const QTextStream::Encoding codes[4]={ QTextStream::Unicode, QTextStream::UnicodeUTF8,
	QTextStream::UnicodeReverse, QTextStream::Latin1 };
// static const char *codeName[2]={"ISO-10646-UCS-2", "UTF-8" };
if(code<1)_jmp_: return QTextCodec::codecForLocale();
if(code<SpeCodecCnt){
  QTextStream st;
  st.setEncoding( codes[code-1] );
  return st.codec();
	}

QTextCodec *codec;
if( codec=QTextCodec::codecForIndex( code-SpeCodecCnt ) )
	return codec;
else goto _jmp_;
}

void setMenuChk(QPopupMenu *code, QPopupMenu *sub, int c, bool b)
{
if(c<SpeCodecCnt)code->setItemChecked(code->idAt(c), b);
else sub->setItemChecked( sub->idAt(c-SpeCodecCnt), b);
}

int popCodecMenu(QWidget *wdg, QPopupMenu *codecMenu, QPopupMenu *popCodec, int prgcode, int c)
{
static const char slot_codec[]=SLOT(codec(int));
QTextCodec *code;
char buff[128];
int id, j;
if(c<0)c=0;
for(j=0; ( code=QTextCodec::codecForIndex(j) ); j++)
	popCodec->insertItem(code->name(), j+SpeCodecCnt);
popCodec->setFont(wdg->font());
popCodec->setCheckable(true);
codecMenu->setFont(wdg->font());
codecMenu->setCheckable(true);
sprintf(buff, localSet, QTextCodec::codecForLocale()->name());
const char *codeNames[5]={ buff, Union16, Union8, "MicroSoft Unicode", "Latin1" };
for(j=0; j<5; j++)
	codecMenu->setItemParameter(codecMenu->insertItem( QString::fromUtf8(codeNames[j]), wdg,  slot_codec), j);
codecMenu->insertItem(QString::fromUtf8(moreCodec), popCodec);
if(prgcode>-2){
	codecMenu->insertSeparator();
	id=codecMenu->insertItem(QString::fromUtf8(defCodec), wdg, SLOT(asDC()));
	codecMenu->setItemChecked(id, prgcode!=-1&&c==prgcode);
	}
setMenuChk(codecMenu, popCodec, c, true);
wdg->connect( popCodec, sigactIdx,  wdg, slot_codec );
return id;
}

static const char utf8[]="UTF-8";
void setCurCodeVal()
{
if(strCodec==QTextCodec::codecForLocale())currentCodec=1;
else if(strCodec==QTextCodec::codecForName(utf8))currentCodec=0;
	else currentCodec=2;
}

const QString tranText(QTextCodec *code, const char *txt/*, QTextCodec **rtCode*/)
{
if(code==NULL)code=strCodec;
const QString s(code->toUnicode(txt));
if(strcmp(code->fromUnicode(s), txt)==0){
//	rtCode=code;
	return s;
	}
else switch(currentCodec){
	case 0 :  local:	// rtCode=QTextCodec::codecForLocale();
		return QString::fromLocal8Bit(txt);
	case 1 :  utf_8:	// rtCode=QTextCodec::codecForName(utf8);
		return QString::fromUtf8(txt);
	}

if(strcmp((QString::fromUtf8(txt)).utf8(), txt)==0)goto utf_8;
else goto local;
}

int getMode(const char *pt, bool *xtag)
{
struct stat64 st, lnkst;
lstat64(pt, &lnkst);
if(stat64( pt, &st )){
	*xtag=false;
	return ICO_LINKNONE;
	}
if(isReadable( uId, gId, &st )==false)return ICO_NOREAD;
*xtag=isExecable( uId, gId, &st);
if(S_ISDIR(st.st_mode)){
	if(strcmp(pt,home)==0)return ICO_HOMEDIR;
	if(S_ISLNK(lnkst.st_mode))return ICO_LINKOBJ;
	if(!*xtag)return ICO_NOEXEC;
	return isWritable(uId, gId, &st)?  0 : ICO_NOWRITE;
	}

if(namefilters(pt, archNam, 1))return ICO_ARCH;
if(S_ISLNK(lnkst.st_mode))return ICO_LINKOBJ;
return (*xtag ? ICO_EXEC_FILE:0);
}

const QPixmap *selectFPix(int Sym)
{
// XWR L => 1,2,4,(对应的反信息)   8, 16
// R
// 将来有多种情况的重合，还要细
if(Sym&ICO_LINKNONE)return lnklost;
else if(Sym&ICO_NOREAD)return filelock;
     else if(Sym&ICO_ARCH)return archfile;
        else if(Sym&ICO_LINKOBJ)return lnkfile;
	else if(Sym&ICO_EXEC_FILE)return execfile;
return filepix;
}

const QPixmap *_selectFPix(int Sym)
{
if(Sym&ICO_LINKNONE)return _lnklost;
else if(Sym&ICO_NOREAD)return _filelock;
    else if(Sym&ICO_ARCH)return _archfile;
       else if(Sym&ICO_LINKOBJ)return _lnkfile;
	else if(Sym&ICO_EXEC_FILE)return _execfile;
      return _filepix;
}

const QPixmap *selectDPix(int Sym)
{
  if(Sym&ICO_NOREAD)return dirlock;
  else if(Sym&ICO_LINKOBJ)return lnkdir;
        else if(Sym&ICO_NOEXEC)return dirnoExec;
	else if(Sym&ICO_NOWRITE)return dirnoWrite;
		else if(Sym&ICO_HOMEDIR)return homedir;
  return dirpix;
}

const QPixmap *_selectDPix(int Sym)
{
  if(Sym&ICO_NOREAD)return _dirlock;
  else if(Sym&ICO_LINKOBJ)return _lnkdir;
        else if(Sym&ICO_NOEXEC)return _dirnoExec;
	else if(Sym&ICO_NOWRITE)return _dirnoWrite;
		else if(Sym&ICO_HOMEDIR)return _homedir;
  return _dirpix;
}

const QPixmap *selectTagPix(int Sym)
{
  int img;
  if(Sym&ICO_NOREAD)img=dirlocktagImg;
//  else if(Sym&ICO_LINKOBJ)return lnkdir;
        else if(Sym&ICO_NOEXEC)img=dirnoExectagImg;
	else if(Sym&ICO_NOWRITE)img=dirnoWritetagImg;
	        else  if(Sym&ICO_LOSTTAGS)img=dirtagLostImg;
		else img=dirtagImg;
  return pixmapLoad(img);
}

void statusBarMsg(StatusPanel *sbar, const char *fmt, const char *pt, int color, int posStat)
{
char *buf;
if(fmt){
	buf=(char *)malloc(strlen(fmt)+strlen(pt)+20);
	sprintf(buf, fmt, pt);
}
sbar->showMsg( fmt ? (const char *)buf:pt, 98, posStat, color );
if(fmt)free(buf);
}

void showLink(StatusPanel *sbar, const char *fmt, const char *pt, unsigned int C)
{
char buff[2032];
int sz=readlink(pt,buff,2031);
if(sz!=-1){
	buff[sz]=0;
	statusBarMsg(sbar, fmt, buff, C);
}
else statusBarMsg(sbar, isBadFile, pt, 0x802020);
}

int wx, wy;
bool SetWdgPos(QWidget *wdg, fsp_dir *dir, int nmb,int wdgSz)
{
MAU mau;
if( numbRead(dir, nmb, &mau,1, false )>-1 ){
  int b, *ipt=(int *)mau.buf;
  if(wdg && (b=ipt[2])>0 ){
	if(wdgSz)wdg->setGeometry( ipt[0], ipt[1], ipt[2], ipt[3]);
	else {
		wdg->resize(QSize(ipt[2],ipt[3]));
		wdg->move(QPoint(wx=ipt[0], wy=ipt[1]));
		}
	}
  free(ipt);
  return b>0;
}
return false;
}

void SaveWdgPos(QWidget *wdg, fsp_dir *dir, int nmb, int wdgSz)
{
 int var[4];
 MAU mau;
 if(wdgSz){
	var[0]=wdg->geometry().x();
	var[1]=wdg->geometry().y(); 
 }
 else {// setWdgFrame
	var[0]=wdg->x(); var[1]=wdg->y(); 
//	var[2]=wdg->width(); var[3]=wdg->height(); // no frameGeometry().height(), because use resize() when setWdgFrame, look above
 }
 var[2]=wdg->width(); var[3]=wdg->height();
 mau.buf=(char *)var;	mau.len=sizeof(int)*4;	mau.alen=0;
 numbWrite(dir, nmb, &mau, 1 );
}

static const char Data2[]="data2";
void SavFont(const QFont &fnt, int numb)
{
fsp_dir *dir=_diropen((fsp_dir *)fspRoot, Data2);
if(dir){
MAU mau[2];
int var[4];
memset(mau, 0, sizeof(mau));
mau[0].buf=strdup(fnt.family().local8Bit());
mau[1].buf=(char *)var;	mau[1].len=sizeof(var);
var[0]=fnt.pointSize();
var[1]=fnt.italic();
var[2]=fnt.bold();
var[3]=fnt.underline();
numbWrite(dir, numb, mau, 2 );
pd_close(dir, 2);
free(mau[0].buf);
}
}

bool ReadFont(QFont &fnt, int numb)
{
fsp_dir *dir=_diropen((fsp_dir *)fspRoot, Data2);
if(dir){
  MAU send[2];
  int rt=numbRead(dir, numb , send, 2, false);
  pd_close(dir,2);
  if( rt>-1 ) {// 此最终起决定作用
	int *var=(int *)send[1].buf;
	fnt.setFamily(QString::fromLocal8Bit(send[0].buf));
	fnt.setPointSize(var[0]);
	fnt.setItalic(var[1]);
	fnt.setBold(var[2]);
	fnt.setUnderline(var[3]);
	freeMAU(send,2);
	return true;
  }
}
return false;
}

const char **charsFromFSP(int id)
{
MAU mau;
if(numbRead(selfDir, id, &mau, 1, true)>-1){
	FastBlock rtdata(AllNoFree);
	rtdata.getFromMau(&mau);
	rtdata.memDiv(NULL);
	return (const char **)rtdata.plist();
}
else return NULL;
}

void setListColWidth(QListView *vList, int num)
{
MAU mau;
if(numbRead(fspRoot, num, &mau, 1, false)>-1){
    int i, *w=(int *)mau.buf, cn=vList->columns(),
	t=mau.len/sizeof(int);
    for( i=0; i<t && i<cn; i++ )
	vList->setColumnWidth(i,w[i]);
    free(w);
}
}

void saveListColWidth(QListView *vList, int num)
{
MAU mau;
int i, cn=vList->columns(), w[cn];
for( i=0; i<cn; i++ )w[i]=vList->columnWidth(i);
mau.buf=(char *)w;
mau.len=sizeof(int)*cn /* 总共有7项 */;
mau.alen=sizeof(int)*7;
numbWrite(fspRoot, num, &mau, 1);
}

#include "warn_png.c"

QPixmap *pixmapLoad(int id)
{
static const char png[]="PNG";
static QPixmap staticPix;
MAU mau[2];
if(id>-1 && numbRead(iconDir, id, mau, 2, true )>-1){
	staticPix.loadFromData( (const uchar *)mau->buf, mau->len, mau[1].buf ? mau[1].buf : png );
	freeMAU(mau,2);
}
else staticPix.loadFromData(warn_png, 3352, png);
return &staticPix;
}

int baseHeight=16, _baseH_=16,
 screenWidth, screenHeight;

void getBaseHeight(const QFont & fnt)
{
 QFontMetrics fm(fnt);
 baseHeight=fm.height();
 if(_baseH_<16)_baseH_=16;
 if(_baseH_>baseHeight)_baseH_=baseHeight;

// qWarning("%d,%d,%d", baseHeight, fnt.pixelSize(), fnt.pointSize());
// fnt.pixelSize() Returns the pixel size of the font if it was set with setPixelSize(). Returns -1 if the size was set with setPointSize() or setPointSizeFloat().
// so use QFontInfo, example qWarning("%d,%d", baseHeight, fnt.pixelSize());=> 13, -1.  and fnt.pointSize() like as
}

int uId, gId, *usrIDs, *groupIDs;

// ============= filesor ================

int subDirCount(const char *dirnam)
{
  int cnt=-2;
  DIR *dir=opendir(dirnam);
  if(dir){
	while( readdir(dir) )cnt++;
	closedir(dir);
	}
  return cnt;
}

FastBlock logNam(Brows); // OnlyAdd
char *logorName(int uid, int *IDs, FastBlock *lst)
{
char buf[12];
int i;
for(i=0; i<lst->count(); i++)
	if(uid==IDs[i])return lst->lstIndex(i);

sprintf(buf, "%d", uid);
if((i=logNam.find(buf))<0)i=logNam.add(buf);
return logNam.lstIndex(i);
}

int isExist(const char *fnam, struct stat64 *sb)
{
if( lstat64(fnam, sb) )return none_File;
if( S_ISLNK(sb->st_mode) ){
      if( stat64(fnam,sb) ){ 
	sb->st_size=0;
	return lost_Link;
	}
     else return symLink;
}
return 0;
}

// ============ filesor run ================
QAction *addToolAction(QWidget *wdg, QToolBar *tools, int Img, const char *tips, const char *menuText,
	const char *slot, int key, bool togg, bool on)
{
const QPixmap pix;
QAction *act=new QAction(QString::fromUtf8(tips), Img>-1 ? *pixmapLoad(Img) : pix,
	QString::fromUtf8(menuText), key, wdg, NULL, togg);
if(slot)wdg->connect(act, sigact, wdg, slot);
if(tools){
	act->setOn( on );
	act->addTo(tools);
	}
return act;
}

QAction *creatToolAction(QWidget *w, QToolBar *tb, int img, const char *txt, const char *slot, int key)
{
return addToolAction(w, tb, img, txt, NULL, slot, key, 0,0);
}

void setListOption(ListOptions *opt, struct stat64 &st, bool lnk, int cnt)
{
switch(cnt){
case no_Right : opt->isNoRead=true;
	break;
case lost_Link : opt->isLost=true;
//	opt->siz=st.st_size;
//	break;
default : opt->siz=S_ISDIR(st.st_mode) ? cnt : st.st_size;
}

opt->mtm=st.st_mtime;
opt->atm=st.st_atime;

opt->uId=st.st_uid;
opt->gId=st.st_gid;

opt->uName=logorName(st.st_uid, usrIDs, usrList);
opt->gName=logorName(st.st_gid, groupIDs, grpList);

opt->type=genFile;
opt->mode=st.st_mode;
opt->isLnk=lnk;
}

FastBlock opens(OnlyAdd);
bool creatOpenMenu(QPopupMenu &pop, QWidget *obj, const char *fn)
{
static const char slot_opens[]=SLOT(opens(int)),
	div[]=":,";
bool rt=false;
if( FileAssoc ){
    MAU mau[3];
    int  i=1, n=0, cnt=FileAssoc->selfnumbs-1;
    pop.setFont(obj->font());
    struct stat64 st;
    stat64(fn, &st);
    if(S_ISDIR(st.st_mode)){
	if(numbRead(FileAssoc, 0, mau,2, true)>-1){
		free(mau[1].buf);
		opens.getFromMau(mau);
		opens.memDiv(div);
		goto _skp_;
		}
	return false;
	}
    _filesor_loop: opens.resetMem(NULL);
    if(n<cnt&&i<0xffff){
	if(numbRead(FileAssoc, i++, mau,2, false)>-1){
	  rt=namefilters(fn, mau[1].buf, 1);  n++;
	  free(mau[1].buf);
	  if(rt==false){
		free(mau[0].buf);
		goto _filesor_loop;
		}
	  opens.getFromMau(mau);
	  opens.memDiv(div);
	}
   }
   if( rt )_skp_: for(i=0; i<opens.count(); i++)pop.insertItem(QString::fromUtf8( opens.lstIndex(i) ), obj, slot_opens, 0, i);
   else {
	QPopupMenu *menu1;
	int b, t=0, id;
	i=1;	n=0;
	opens.resetMem(NULL);
	while(n < cnt && i<0xffff)
	    if(numbRead(FileAssoc, i++, mau,3, false)>-1){
		FastBlock lst;
		free(mau[1].buf);	n++;
		menu1=new QPopupMenu(obj);
		pop.insertItem(QString::fromUtf8(mau[2].buf),menu1); 
		free(mau[2].buf);
		lst.getFromMau(mau);
		lst.memDiv(div);
		for(b=0; b<lst.count(); b++){
			opens.add(lst.lstIndex(b));
			id=menu1->insertItem(QString::fromUtf8( lst.lstIndex(b) ), obj, slot_opens, 0, b);
			menu1->setItemParameter(id, t++);
			}
		}
	opens.memDiv(NULL);
	}
return true;
}
return false;
}

char *parentDirIndex(const char *dirnam, const char *par)
{
char *pIdx=strrchr( (char *)dirnam, '/');
int t=pIdx-dirnam;
return (memcmp(dirnam, par, t )==0 && par[t]==0) ? pIdx+1 : NULL;
}

const uchar *getImageData(const char *filenam, unsigned int &L)
{
FILE *fp=fopen(filenam, "rb");
if(fp){
	fseek(fp, 0, SEEK_END);
	L=ftell(fp);
	char *buf=(char *)malloc(L+2);
	fseek(fp, 0, 0);
	fread(buf, L, 1, fp);
	fclose(fp);
	return (const uchar *)buf;
}
return NULL;
}

void scaleImage(QImage &img, int lmt)
{
	int hg=img.height(),  wd=img.width();
	if((hg<wd ? hg : wd)> 128){ // min
	    if(hg>lmt)img=img.scale( wd*lmt/hg, lmt );
	    else if(wd>lmt)img=img.scale(lmt, hg*lmt/wd);
	}
	else {
	    if(hg>lmt)img=img.smoothScale( wd*lmt/hg, lmt );
	    else if(wd>lmt)img=img.smoothScale(lmt, hg*lmt/wd);
	}
}

// -1 no; -2 is image; >=0 is ItemPixmap[i] (link)
int setItemImage(const char *fn, int lmt, QImage *imgbrw, FastBlock *imgftmp)
{
	const char *filenam;
	char *buff;
	bool msg;
	int L, i, C, m;
	struct stat64 sb;
	lstat64( fn, &sb ); //==0 && 
	m=sb.st_mode;
	if( is_dev(m) )return -1;
	buff=(char *)malloc(8192);
	if( S_ISLNK(m) ){
		C=readlink(fn, buff, 8191);
		buff[C]=0;
		if(buff[0]!='/'){
			const char *ptr=strrchr(fn, '/');
			L=ptr-fn+1;
			for(i=C; i>-1; i--)buff[i+L]=buff[i];
			for(i=0; i<L; i++)buff[i]=fn[i];
		}
		filenam=buff;
	}
	else filenam=fn;
	C=imgftmp ? imgftmp->find(filenam) : -1;
	if(C<0){
		unsigned int Len;
		const uchar *buf=getImageData(filenam, Len);
		if(buf){
		  msg=imgbrw->loadFromData(buf, Len);
		  free((void *)buf);
		  if( msg ){
		    if(imgftmp)imgftmp->add(filenam);
		    scaleImage(*imgbrw, lmt);
		  }
	 	}
		else msg=false;
	}
	free(buff);
	return C<0 ? (msg? -2 : -1) : C;
}

void FileStat(ListOptions *sb, const char *opt, LVItem *it, const char *dtfmt, int off)
{
int i, t, V;
for(t=0; (V=opt[t]); t++)
	switch(V){ //"大小", "修改时", "访问时", "属主", "组", "权限", "类型"
	case 1 :	{
		char sizbuf[16];
		static const char *_type[5]={ "_chr ", "_blk ", "fifo ", "sock ", "NoRead" };
		int m=sb->mode, idx;
		if(sb->isNoRead)idx=4;
		   else if(S_ISCHR(m))idx=0;
		        else if(S_ISBLK(m))idx=1;
			else if(S_ISFIFO(m))idx=2;
			        else if(S_ISSOCK(m))idx=3;
				  else {
					if(S_ISDIR(m))sprintf(sizbuf, "%llu Unit " , sb->siz);
					else sprintf( sizbuf, "%llu ",  sb->siz);
					goto _jmp_;
					}
		scopy(sizbuf, _type[idx]);
	_jmp_:	it->setText(t+off,sizbuf);
		}
		break;
	case 2 : 
	case 3 :
		{
		QDateTime fsdt;
		fsdt.setTime_t(V!=3 ? sb->mtm : sb->atm);
		it->setText(t+off, fsdt.toString(dtfmt));
		}
		break;
	case 4 : it->setText(t+off, sb->uName);
		break;
	case 5 : it->setText(t+off, sb->gName);
		break;
	case 6 : {
		static const char modefmt[]="%c%c%c ";
		int M;
		char attbuf[20];
		*attbuf=32;
		for(i=2; i>-1; i--){
			M=sb->mode>>(i*3);
			sprintf(attbuf+1+(2-i)*4, modefmt, M&04 ? 'r':'-', M&02 ? 'w':'-', M&01 ? 'x' : '-');
			}
		attbuf[1+3*4]=32;
		M=sb->mode>>(3*3);
		sprintf(attbuf+1+3*4+1, modefmt, M&04 ? 'U':'.', M&02 ? 'G':'.', M&01 ? 'T' : '.');
		it->setText(t+off, attbuf);
		}
		break;
	case 7 :it->setText(t+off, QString::fromUtf8(sb->type));
	}
}

void *vInsertItem(QScrollView *vw, const char *fnam, int msg, int sz,
	const char *cols, const char *dtfmt, void *codec, void *_pos)
{// msg: 0 copy;  2 is ListOpera(attrib chang);
// -2 sm-add; -1 change(or listSet); -3 sm-notify(timer), -4 sm-sort, -5 add sm-listopera
#define  IS_SM(msg)  (msg<0)
char *nam, *smfn;
if(IS_SM(msg)){
	smfn=catstr(" ", fnam, 32); // 用于表达
	nam=strrchr(smfn, '/');
	if(nam==NULL)return NULL;
	*nam++=0;
	}
else {
	nam=(char *)strrchr(fnam, '/');
	if(nam==NULL)return NULL;
	nam++;
}
int i, fIco, brw_img,
	isList=strcmp(vw->name(), vIcon);
bool  x, isDir;
struct stat64 sb, slnk;
ListOptions *opt;
LVItem *it;
IVItem *ico;
QImage img;
if(sz>0)brw_img=setItemImage(fnam, sz, &img, NULL);
else brw_img=-1;
fIco=getMode(fnam, &x);
if(msg!=View_Add&&msg!=SM_Notify&&msg!=Opts_Chang){
   i=stat64( fnam, &sb) ? lost_Link : 0;
   lstat64(fnam, &slnk);
   if(i)sb=slnk;
   isDir=S_ISDIR(sb.st_mode);
}
else {
	opt=(ListOptions *)codec;
	isDir=opt->isLost ? false : S_ISDIR(opt->mode);
	}
if(isList){
	QListView *vlist=(QListView *)vw;
	ListOptions optbuf;
	switch(msg){
	case View_Add : it=new LVItem(vlist, (LVItem *)_pos, nam, NULL, isDir);
			    it->setRenameEnabled(0,true);
		break;
	case SM_Notify :
	case Opts_Chang :	it=(LVItem *)_pos; 
		break;
	default : 
		optbuf.isLost=false; optbuf.isNoRead=false; // init only thus, memset(&opt, 0, sizeof(ListOptions));
		opt=&optbuf;
		setListOption(opt, sb, S_ISLNK(slnk.st_mode), isDir ? subDirCount(fnam) : i );
		switch(msg){
		case ListSet_Chang : it=(LVItem *)((ListOptions *)_pos)->item;
		case LO_SM_Add :
		case SM_Add : *(ListOptions *)_pos=optbuf;
			if(msg!=ListSet_Chang){
			    it=new LVItem(vlist, (LVItem *)vlist->lastItem(), msg==LO_SM_Add ? (0x00c000<<8) : 0);
			    it->setRenameEnabled(0,true);
			}
			break;
		case SM_Sort : it=((LVItem *)_pos);
			it->setText(0,tranText((QTextCodec *)codec, nam));
			}
	}
	if( (msg==SM_Add||msg==LO_SM_Add) ||msg==SM_Sort){
//		it->_set_name(fnam);
		it->setText(0, tranText((QTextCodec *)codec, nam));
		it->fnam=(char *)fnam;
		it->setText(1, tranText((QTextCodec *)codec, smfn));
		free(smfn);
		}
	FileStat( opt, cols, it, dtfmt, IS_SM(msg) ? 2 : 1 );
	it->setPixmap(0, brw_img!=-1 ? img : (isDir ? *selectDPix(fIco) : *selectFPix(fIco) ));
	if(msg==View_Add){
		vlist->ensureItemVisible( it );
		vlist->setSelected(it, true);
		vlist->setCurrentItem(it);
	}
}
else {
	QIconView *vIcon=(QIconView *)vw;
	switch(msg){
	case View_Add : if( (x=(_pos==NULL&&vIcon->firstItem())) )_pos=vIcon->firstItem();
		ico=new IVItem( vIcon, (IVItem *)_pos , nam,
			brw_img!=-1 ? img : (isDir? *_selectDPix(fIco) : *_selectFPix(fIco)) , NULL, isDir, isDir && fIco!=ICO_NOEXEC && fIco!=ICO_NOWRITE );
		if(x){
			vIcon->takeItem((IVItem *)_pos);
			vIcon->insertItem((IVItem *)_pos, ico);
		}
		ico->setRenameEnabled(true);
		vIcon->ensureItemVisible( ico );
		vIcon->setSelected(ico,true);
		vIcon->setCurrentItem(ico);
		break;
	default  :
		ico= msg!=Opts_Chang ? 
			(IVItem *)vIcon->findItem(tranText((QTextCodec *)codec,nam),  Qt::ExactMatch|Qt::CaseSensitive)
			: (IVItem *)_pos;
		ico->setPixmap(brw_img!=-1 ? img : (isDir? *_selectDPix(fIco) : *_selectFPix(fIco)));
	}
	}
 return isList ? (void *)it : ico;
}

void procDrop(QWidget *wdg, Filesan *fs, QDropEvent *e, const char *dst)
{
int i;
static const char dropTag[]="file://";
QStrList lst;
QUriDrag::decode( e, lst );
if(lst.count()>0){
  FastBlock chs;
  const char *pt, *fn;
  for( i=0; i<lst.count(); i++){
	fn=lst.at(i);
	pt=strstr(fn, dropTag);
	if(pt==fn)fn+=sizeof(dropTag)-1;
	chs.add( fn );
  }
  new CopyThread(wdg, fs, chs, dst, e->action()|32);// FCOPY, FMOVE, FLINK
  e->accept();
}
}

int _delFile(QWidget *wdg, const char *pt)
{
struct stat64 adjust;
int rt;
if(lstat64(pt, &adjust) && access(pt,F_OK)){
  ErrorQuestion(wdg, normError, pt, delError);  return 1;
 }

if((adjust.st_mode&S_IFLNK)==S_IFLNK){
	if( (rt=unlink(pt)) )goto _skpErr_;
}
else if( (rt=__operaDir(wdg, TEST_REMOVE_DIR, pt, NULL, NULL)) )
	_skpErr_: ErrorQuestion(wdg, normError, pt, delError);
return rt;
}

static void adjustOpera(const char *chs, int id, int &rt2, QWidget *wdg, int *__errno)
{
    int i, err_no=errno;
    for(i=0; __errno[i]&&__errno[i]!=err_no; i++);
    if( __errno[i]==0 /*|| rt2!=cp_ignoreStat */)
	switch(ErrorQuestion(wdg, id, chs)){
	case 1 : // rt2=cp_ignoreStat;
		for(i=0; __errno[i]; i++);
		__errno[i]=err_no;
		break;
	case 2 : rt2=cp_ignoreThrow;
		break;
	case 3 : rt2=opera_cancel;
	}
}

static int operaDir(QWidget *wdg, int Msg, const char *dirnam, const char *filters, const struct fAttribRslt *fattr, int *_errno, int loops)
{
struct stat64  src_st, mode;
if( stat64(dirnam, &src_st) ){
	postErrInfo(fattr->wdg? fattr->wdg : wdg, ErrorQ, dirnam, warnChs);
	return  lost_Link;
}
if(Msg==CHMODE)chmod(dirnam, 0700);
else if( access(dirnam, R_OK) ){
	postErrInfo(fattr->wdg? fattr->wdg : wdg, ErrorQ, dirnam, warnChs);
	return no_Right;
	}
int j, rt=0, L=strlen(dirnam);
char *chs=(char *)malloc(L+258);
scopy(chs, dirnam);
if(chs[L-1]!=ROOT_CH)chs[L++]=ROOT_CH;
DIR *dir;
if(fattr && fattr->chSub==false || !(dir=opendir(dirnam)) )goto _skp_;
const char *fnam;
struct dirent *dire;

while( loops && rt!=opera_cancel && rt!=cp_ignoreThrow && rt!=opera_error && ( dire=readdir(dir))!=NULL ){
    fnam=dire->d_name;
    if( ! (fnam[0]=='.' && (fnam[1]==0 ||( fnam[1]=='.'&&fnam[2]==0))) ){
	scopy(chs+L, fnam);
	lstat64(chs, &mode);
	if(stat64(chs, &src_st)==0 && S_ISDIR(src_st.st_mode)){
		switch(Msg){
		case TEST_REMOVE_DIR :
			if( (mode.st_mode&S_IFLNK)==S_IFLNK ? unlink(chs) : deleteDir(wdg, chs, filters, _errno, 1+loops) ){
				rt=opera_error;
				ErrorQuestion(wdg, normError, chs, delError);
				}
			else if((mode.st_mode&S_IFLNK)!=S_IFLNK&&namefilters(fnam, filters,3) )goto _rmfile_;
			break;
		case RENCASE1 :
		case RENCASE0 : rt=operaDir(wdg, Msg, chs, filters , NULL, _errno, 1+loops);
			goto _rencase_;
		case CHMODE : rt=operaDir(wdg, CHMODE, chs, filters, fattr, _errno, 1+loops);
			goto _chmode_;
		case CHIDS : rt=operaDir(wdg, CHIDS, chs, filters, fattr, _errno, 1+loops);
			goto _chids_;
		case CH_TIME : rt=operaDir(wdg, CH_TIME, chs , filters, fattr, _errno, 1+loops);
			goto _ch_time_;
		}
	}
	else if(namefilters(fnam, filters, 3)){
		switch(Msg){
		case TEST_REMOVE_DIR : _rmfile_: 
			if((mode.st_mode&S_IFLNK)!=S_IFLNK)_rm_file : rt=remove(chs);
			else  rt=unlink(chs);
			if( rt ){ // remove!=unlink
				rt=opera_error;
				ErrorQuestion(wdg, normError, chs, delError);
				}
			break;
		case RENCASE1 :
		case RENCASE0 : _rencase_: {
			char ch, dbuf[257], *dst;
			for(j=0; (ch=fnam[j]); j++){
				if(Msg==RENCASE0)dbuf[j]=(ch > 'A'-1 && ch < 'Z'+1 ) ? ch|32 : ch ;
				else dbuf[j]=(ch > 'a'-1 && ch < 'z'+1 ) ? ch & ~32 : ch ;
			}
			dbuf[j]=0;
			dst=catstr(dirnam, dbuf, ROOT_CH);
			if(rename(chs,dst))adjustOpera(chs, renCaseError, rt, wdg, _errno);
			free((void *)dst);
			if(loops==0){ free((void *)dirnam); return rt; }
			}
			break;
		case CHMODE :  _chmode_: if(chmod( chs, fattr->mode ))
				adjustOpera(chs, chmodError, rt, fattr->wdg? fattr->wdg : wdg, _errno);
			break;
		case CHIDS : _chids_ : if(chown( chs, fattr->uid, fattr->gid ))adjustOpera(chs, chownError, rt, fattr->wdg? fattr->wdg : wdg, _errno );
			break;
		case CH_TIME : _ch_time_ : if(chtime(chs, &fattr->sb) )adjustOpera(chs, chtimeError, rt, fattr->wdg? fattr->wdg : wdg, _errno );
		}
	}
    }
}
if(loops==1){
   closedir(dir);
_skp_:	chs[L-1]=0;   loops=0;
	switch(Msg){
	case TEST_REMOVE_DIR : 
		if(rt)goto _ex_;
		goto _rm_file;
	case CH_TIME : goto _ch_time_;
	case CHIDS : goto _chids_;
	case CHMODE : goto _chmode_;
	}
	char *tmp=strrchr(chs, '/');
	if(tmp!=chs){
		*tmp=0;
		fnam=tmp+1;
		tmp=chs;
		chs=(char *)dirnam;
		dirnam=tmp;
		goto _rencase_;
	}
}
_ex_: free(chs);
return rt; // !=opera_cancel ? (rt2<0  ? 128 : rt2) : opera_cancel; 
}

int __operaDir(QWidget *wdg, int Msg, const char *dirnam, const char *filters, const struct fAttribRslt *fattr)
{
QApplication::setOverrideCursor( Qt::WaitCursor );
int msg, *_errno=(int *)zalloc(128*sizeof(int));
msg=operaDir(wdg, Msg, dirnam, filters, fattr, _errno, 1);
free(_errno);
QApplication::restoreOverrideCursor();
return msg;
}

class QUMethod;
extern const char **colName, clickSig[]; // filesan.h
extern const QUMethod slot_0_0; 
const QMetaData upSlot={ "Up()" , &slot_0_0, QMetaData::Private },
	downSlot={ "Down()" , &slot_0_0, QMetaData::Private };
const char slot_up[]=SLOT(Up()), slot_down[]=SLOT(Down());
void listSetInit(QWidget *wdg, ListContent **list, const QRect &rect, QPushButton **up, QPushButton **down, const char *colsInfo)
{
int t, i;
LVItem *it;
const char *pval=colsInfo+colOptCnt;
QWidget *parentWdg=wdg->topLevelWidget();
ListContent *optList=new ListContent(wdg, OptListChs, T_OptList, (Filesan *)parentWdg->parentWidget() );
QPushButton *upBtn=new QPushButton(wdg),
	*downBtn=new QPushButton(wdg);
optList->setGeometry( rect );

optList->setSorting(-1);
i=optList->width();

optList->addColumn(QString::fromUtf8(fieldChs0), t=i*2/3 );
optList->addColumn(QString::fromUtf8(fieldChs1), i-t-6);

for(i=colOptCnt-1; i>-1; i--){
	it=new LVItem(optList, /* after , if i==0 first ... */QString::fromUtf8(colName[colsInfo[i]-1]));
	it->setType(pval[i] ? 0x207020<<8 : 0);
	it->setText(1, pval[i] ? "Yes" : "No");
	}

upBtn->setPixmap(*pixmapLoad(mvupImg));
parentWdg->connect(upBtn, clickSig, parentWdg, slot_up );

downBtn->setPixmap(*pixmapLoad(mvdownImg));
parentWdg->connect(downBtn, clickSig, parentWdg, slot_down);
*list=optList;
*up=upBtn;	*down=downBtn;
}

void moveListSet(ListContent *optList, char *colsInfo, int btn)
{ // btn : 0=Up
	int t=0, i=0, Idx;
	unsigned int C;
	LVItem *itm=(LVItem *)optList->currentItem(),
	*it=(LVItem *)optList->firstChild();
	if(itm==optList->lastItem()&&btn==1)return;;
	while(itm!=it&&it){ i++; it=(LVItem *)it->nextSibling(); }
	Idx=colsInfo[i];
	colsInfo[i]=colsInfo[i+(btn!=1 ? -1:1)];
	colsInfo[i +(btn!=1 ? -1:1)]=Idx;
	QString s0(itm->text(0)), s1(itm->text(1));
	it=(LVItem *)optList->firstChild();
	while( t++ < i+(btn!=1 ? -1:1) )it=(LVItem *)it->nextSibling();
	C=itm->getType();
	itm->setType(it->getType());
	itm->setText(0,it->text(0));
	itm->setText(1,it->text(1));
	it->setType(C);
	it->setText(0,s0);
	it->setText(1,s1);
	optList->setSelected(it, true);
}

void getListOpts(ListContent *optList, char *pval)
{
int i=0;
LVItem *it=(LVItem *)optList->firstChild();
while( i<colOptCnt ){
	pval[i++]=it->getType()>>8; // >0xff ? 1:0; //strcmp(it->text(1),showN);
	it=(LVItem *)it->nextSibling();
	}
}
